#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Version=beta
#AutoIt3Wrapper_icon=icon.ico
#AutoIt3Wrapper_outfile=Vistumbler.exe
#AutoIt3Wrapper_Run_Tidy=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
;--------------------------------------------------------
;AutoIt Version: 3.2.9.3 Beta
$Script_Author = 'Andrew Calcutt' 
$Script_Start_Date = '07/09/2007' 
$Script_Name = 'Vistumbler' 
$Script_Function = 'A netstumbler like program for vista. This Program uses "netsh wlan show networks mode=bssid" to get wireless information.' 
$version = 'v7 Beta Pre-Release 3' 
$last_modified = '11/1/2007' 
$title = $Script_Name & ' ' & $version & ' - By ' & $Script_Author & ' - ' & $last_modified
;Includes------------------------------------------------
#include <File.au3>
#include <Array.au3>
#include <Process.au3>
#include <GuiConstants.au3>
#Include <GuiListView.au3>
#include <WindowsConstants.au3>
#include <GuiTreeView.au3>
; Set a COM Error handler--------------------------------
$oMyError = ObjEvent("AutoIt.Error", "MyErrFunc")
;Register-Netcomm-OCX------------------------------------
;_RunDOS('REGSVR32.EXE /s "' & @ScriptDir & '\NETComm.ocx"')
;Options-------------------------------------------------
Opt("TrayIconHide", 1);Hide icon in system tray
Opt("GUIOnEventMode", 1);Change to OnEvent mode
Opt("RunErrorsFatal", 0)
;Non Vista Warning---------------------------------------
If @OSVersion <> "WIN_VISTA"  Then MsgBox(0, "Warning", "This Program will only run in Vista. It relies on a netsh command that is not avalible in older versions of windows")
;Declair-Variables---------------------------------------
;Dim $WS_EX_CONTROLPARENT = 0x00010000
Dim $data_history, $data_old
Dim $sizes, $sizes_old
Dim $base_add = 0, $data, $data_old, $Graph = 0, $Graph_old, $Redraw = 1

Dim $TreeviewAPs_left, $TreeviewAPs_width, $TreeviewAPs_top, $TreeviewAPs_height
Dim $ListviewAPs_left, $ListviewAPs_width, $ListviewAPs_top, $ListviewAPs_height
Dim $Graphic_left, $Graphic_width, $Graphic_top, $Graphic_height

Dim $DataArray_Active[1]
Dim $DataArray_BSSID[1]
Dim $DataArray_SSID[1]
Dim $DataArray_Auth[1]
Dim $DataArray_Encr[1]
Dim $DataArray_Sig[1]
Dim $DataArray_Chan[1]
Dim $DataArray_Rad[1]
Dim $DataArray_Lon[1]
Dim $DataArray_Lat[1]
Dim $DataArray_BtX[1]
Dim $DataArray_OtX[1]
Dim $DataArray_NetType[1]
Dim $DataArray_FirstTime[1]
Dim $DataArray_LastTime[1]
Dim $DataArray_SigHist[1]
Dim $DataArray_Manu[1]
Dim $DataArray_Label[1]
Dim $DataArray_Row[1]

Dim $TmpArray_BSSID[1]
Dim $TmpArray_SSID[1]
Dim $TmpArray_Auth[1]
Dim $TmpArray_Encr[1]
Dim $TmpArray_Sig[1]
Dim $TmpArray_Chan[1]
Dim $TmpArray_Rad[1]
Dim $TmpArray_Lon[1]
Dim $TmpArray_Lat[1]
Dim $TmpArray_BtX[1]
Dim $TmpArray_OtX[1]
Dim $TmpArray_NetType[1]
Dim $TmpArray_Time[1]
Dim $TmpArray_FirstTime[1]
Dim $TmpArray_LastTime[1]
Dim $TmpArray_SigHist[1]
Dim $TmpArray_Manu[1]
Dim $TmpArray_Label[1]

Dim $addposition, $newlat, $newlon, $SigHist, $MANUF, $LABEL
_SetDataArraySizes()
;Active, BSSID, SSID, Signal, Label, Manufacturer, Authentication, Encrytion, Channel, RadioType, Latitude, Logitude, BasicTx, OtherTx, FirstActive, LastUpdated, NetType, SigHist
;Dim $DataArray[1][1][1][1][1][1][1][1][1][1][1][1][1][1][1][1][1][1]
;BSSID, SSID, Authentication, Encryption, Signal, Channel, RadioType, LineInListview
;Dim $TmpDataArray[11][11][11][11][11][11][11][11][11]
;Dim $TmpDataArray[10][10][10][10][10][10][10][10] = [[UBound($TmpDataArray, 1)], [UBound($TmpDataArray, 2)], [UBound($TmpDataArray, 3)], [UBound($TmpDataArray, 4)], [UBound($TmpDataArray, 5)], [UBound($TmpDataArray, 6)], [UBound($TmpDataArray, 7)], [UBound($TmpDataArray, 8)]]
;_ArrayDisplay($TmpDataArray)

Dim $tempfile = _TempFile(@TempDir, "~vistumbler-")
;Dim $tempfile = 'test.txt'
Dim $SettingsDir = @ScriptDir & '\Settings\' 
Dim $LanguageDir = @ScriptDir & '\Languages\' 
Dim $SoundDir = @ScriptDir & '\Sounds\' 
Dim $SaveDir = @ScriptDir & '\Save\' 
Dim $settings = $SettingsDir & 'vistumbler_settings.ini' 
Dim $labelsini = $SettingsDir & 'mac_labels.ini' 
Dim $manufini = $SettingsDir & 'manufactures.ini' 
Dim $Latitude = 'N 0.0000000' 
Dim $Longitude = 'E 0.0000000' 
Dim $UseGPS = 0
Dim $SortList = 0
Dim $Scan = 0
Dim $ComError = 0
Dim $SortColumn = ""
;Dim $disconnected_time = -1
Dim $ResetMacLabel = 0
Dim $ResetManLabel = 0
Dim $NewApFound = 0
Dim $TempFileArray, $OpenArray, $oMyError, $temp, $LatTest, $gps, $NetComm, $CommPort, $Sort, $timestamp, $timestamp1, $timestamp2, $sort_timer, $headers, $basetimestamp, $timestamp_timer
Dim $SSID, $NetworkType, $Authentication, $Encryption, $BSSID, $Signal, $RadioType, $Channel, $BasicTransferRates, $OtherTransferRates, $display, $ActiveBSSIDs, $ActiveBSSIDs_old, $ActiveSSIDs, $ActiveSSIDs_old, $ActiveData, $ActiveData_old
Dim $manu_mac[1], $manu_manu[1], $label_mac[1], $label_label[1], $channel_array[1], $channel_position[1], $SSID_array[1], $SSID_position[1], $Encryption_array[1], $Encryption_position[1], $Authentication_array[1], $Authentication_position[1], $NetworkType_array[1], $NetworkType_position[1]
Dim $Direction[18], $Direction2[4]
Dim $Array_Temp_BSSID[1], $Array_Temp_SSID[1], $Array_Temp_Signal[1], $Array_Temp_Authentication[1], $Array_Temp_Encryption[1], $Array_Temp_RadioType[1], $Array_Temp_Channel[1], $Array_Temp_BasicTransferRates[1], $Array_Temp_OtherTransferRates[1], $Array_Temp_NetworkType[1], $Array_Temp_TimeStamp[1]

;Load-Settings-From-INI-File----------------------------
Dim $DefaultLanguage = IniRead($settings, 'Vistumbler', 'Language', 'English')
Dim $netsh = IniRead($settings, 'Vistumbler', 'Netsh_exe', 'netsh.exe')
Dim $ComPort = IniRead($settings, 'Vistumbler', 'ComPort', 8)
Dim $BAUD = IniRead($settings, 'Vistumbler', 'Baud', 4800)
Dim $saved_sleeptime = IniRead($settings, 'Vistumbler', 'Sleeptime', 1000)
Dim $SortTime = IniRead($settings, 'Vistumbler', 'AutoSortTime', 60)
Dim $SortBy = IniRead($settings, 'Vistumbler', 'SortCombo', 'Sort by SSID')
Dim $SortDirection = IniRead($settings, 'Vistumbler', 'AscDecDefault', 'Decending')
Dim $AutoSort = IniRead($settings, 'Vistumbler', 'AutoSort', 0)
Dim $SoundOnAP = IniRead($settings, 'Vistumbler', 'PlaySoundOnNewAP', 0)
Dim $new_AP_sound = IniRead($settings, 'Vistumbler', 'NewAP_Sound', 'new_ap.wav')
Dim $error_sound = IniRead($settings, 'Vistumbler', 'Error_Sound', 'error.wav')
Dim $AddDirection = IniRead($settings, 'Vistumbler', 'NewApPosistion', 0)
Dim $BackgroundColor = IniRead($settings, 'Vistumbler', 'BackgroundColor', "0x99B4D1")
Dim $ControlBackgroundColor = IniRead($settings, 'Vistumbler', 'ControlBackgroundColor', "0xD7E4F2")
Dim $column_Active = IniRead($settings, 'Columns', 'Column_Active', 0)
Dim $column_SSID = IniRead($settings, 'Columns', 'Column_SSID', 1)
Dim $column_BSSID = IniRead($settings, 'Columns', 'Column_BSSID', 2)
Dim $column_MANUF = IniRead($settings, 'Columns', 'Column_Manufacturer', 3)
Dim $column_Signal = IniRead($settings, 'Columns', 'Column_Signal', 4)
Dim $column_Authentication = IniRead($settings, 'Columns', 'Column_Authentication', 5)
Dim $column_Encryption = IniRead($settings, 'Columns', 'Column_Encryption', 6)
Dim $column_RadioType = IniRead($settings, 'Columns', 'Column_RadioType', 7)
Dim $column_Channel = IniRead($settings, 'Columns', 'Column_Channel', 8)
Dim $column_Latitude = IniRead($settings, 'Columns', 'Column_Latitude', 9)
Dim $column_Longitude = IniRead($settings, 'Columns', 'Column_Longitude', 10)
Dim $column_BasicTransferRates = IniRead($settings, 'Columns', 'Column_BasicTransferRates', 11)
Dim $column_OtherTransferRates = IniRead($settings, 'Columns', 'Column_OtherTransferRates', 12)
Dim $column_FirstActive = IniRead($settings, 'Columns', 'Column_FirstActive', 13)
Dim $column_LastActive = IniRead($settings, 'Columns', 'Column_LastActive', 14)
Dim $column_NetworkType = IniRead($settings, 'Columns', 'Column_NetworkType', 15)
Dim $column_Label = IniRead($settings, 'Columns', 'Column_Label', 16)

Dim $column_Width_Active = IniRead($settings, 'Column_Width', 'Column_Active', 50)
Dim $column_Width_SSID = IniRead($settings, 'Column_Width', 'Column_SSID', 50)
Dim $column_Width_BSSID = IniRead($settings, 'Column_Width', 'Column_BSSID', 50)
Dim $column_Width_MANUF = IniRead($settings, 'Column_Width', 'Column_Manufacturer', 50)
Dim $column_Width_Signal = IniRead($settings, 'Column_Width', 'Column_Signal', 50)
Dim $column_Width_Authentication = IniRead($settings, 'Column_Width', 'Column_Authentication', 50)
Dim $column_Width_Encryption = IniRead($settings, 'Column_Width', 'Column_Encryption', 50)
Dim $column_Width_RadioType = IniRead($settings, 'Column_Width', 'Column_RadioType', 50)
Dim $column_Width_Channel = IniRead($settings, 'Column_Width', 'Column_Channel', 50)
Dim $column_Width_Latitude = IniRead($settings, 'Column_Width', 'Column_Latitude', 50)
Dim $column_Width_Longitude = IniRead($settings, 'Column_Width', 'Column_Longitude', 50)
Dim $column_Width_BasicTransferRates = IniRead($settings, 'Column_Width', 'Column_BasicTransferRates', 50)
Dim $column_Width_OtherTransferRates = IniRead($settings, 'Column_Width', 'Column_OtherTransferRates', 50)
Dim $column_Width_FirstActive = IniRead($settings, 'Column_Width', 'Column_FirstActive', 50)
Dim $column_Width_LastActive = IniRead($settings, 'Column_Width', 'Column_LastActive', 50)
Dim $column_Width_NetworkType = IniRead($settings, 'Column_Width', 'Column_NetworkType', 50)
Dim $column_Width_Label = IniRead($settings, 'Column_Width', 'Column_Label', 50)

Dim $Column_Names_Active = IniRead($settings, 'Column_Names', 'Column_Active', 'Active')
Dim $Column_Names_SSID = IniRead($settings, 'Column_Names', 'Column_SSID', 'SSID')
Dim $Column_Names_BSSID = IniRead($settings, 'Column_Names', 'Column_BSSID', 'Mac Address')
Dim $Column_Names_MANUF = IniRead($settings, 'Column_Names', 'Column_Manufacturer', 'Manufacturer')
Dim $Column_Names_Signal = IniRead($settings, 'Column_Names', 'Column_Signal', 'Signal')
Dim $Column_Names_Authentication = IniRead($settings, 'Column_Names', 'Column_Authentication', 'Authentication')
Dim $Column_Names_Encryption = IniRead($settings, 'Column_Names', 'Column_Encryption', 'Encryption')
Dim $Column_Names_RadioType = IniRead($settings, 'Column_Names', 'Column_RadioType', 'Radio Type')
Dim $Column_Names_Channel = IniRead($settings, 'Column_Names', 'Column_Channel', 'Channel')
Dim $Column_Names_Latitude = IniRead($settings, 'Column_Names', 'Column_Latitude', 'Latitude')
Dim $Column_Names_Longitude = IniRead($settings, 'Column_Names', 'Column_Longitude', 'Longitude')
Dim $Column_Names_BasicTransferRates = IniRead($settings, 'Column_Names', 'Column_BasicTransferRates', 'Basic Transfer Rates')
Dim $Column_Names_OtherTransferRates = IniRead($settings, 'Column_Names', 'Column_OtherTransferRates', 'Other Transfer Rates')
Dim $Column_Names_FirstActive = IniRead($settings, 'Column_Names', 'Column_FirstActive', 'First Active')
Dim $Column_Names_LastActive = IniRead($settings, 'Column_Names', 'Column_LastActive', 'Last Active')
Dim $Column_Names_NetworkType = IniRead($settings, 'Column_Names', 'Column_NetworkType', 'Network Type')
Dim $Column_Names_Label = IniRead($settings, 'Column_Names', 'Column_Label', 'Label')

Dim $SearchWord_SSID = IniRead($settings, 'SearchWords', 'SSID', 'SSID')
Dim $SearchWord_BSSID = IniRead($settings, 'SearchWords', 'BSSID', 'BSSID')
Dim $SearchWord_NetworkType = IniRead($settings, 'SearchWords', 'NetworkType', 'Network type')
Dim $SearchWord_Authentication = IniRead($settings, 'SearchWords', 'Authentication', 'Authentication')
Dim $SearchWord_Encryption = IniRead($settings, 'SearchWords', 'Encryption', 'Encryption')
Dim $SearchWord_Signal = IniRead($settings, 'SearchWords', 'Signal', 'Signal')
Dim $SearchWord_RadioType = IniRead($settings, 'SearchWords', 'RadioType', 'Radio Type')
Dim $SearchWord_Channel = IniRead($settings, 'SearchWords', 'Channel', 'Channel')
Dim $SearchWord_BasicRates = IniRead($settings, 'SearchWords', 'BasicRates', 'Basic Rates')
Dim $SearchWord_OtherRates = IniRead($settings, 'SearchWords', 'OtherRates', 'Other Rates')
Dim $SearchWord_None = IniRead($settings, 'SearchWords', 'None', 'None')
Dim $SearchWord_Open = IniRead($settings, 'SearchWords', 'Open', 'Open')

Dim $Text_Ok = IniRead($settings, 'GuiText', 'Ok', '&Ok')
Dim $Text_Cancel = IniRead($settings, 'GuiText', 'Cancel', 'C&ancel')

Dim $Text_File = IniRead($settings, 'GuiText', 'File', '&File')
Dim $Text_SaveAsTXT = IniRead($settings, 'GuiText', 'SaveAsTXT', 'Save As &TXT')
Dim $Text_ImportFromTXT = IniRead($settings, 'GuiText', 'ImportFromTXT', 'Import From &TXT')
Dim $Text_Exit = IniRead($settings, 'GuiText', 'Exit', 'E&xit')

Dim $Text_Edit = IniRead($settings, 'GuiText', 'Edit', 'E&dit')
Dim $Text_Cut = IniRead($settings, 'GuiText', 'Cut', 'Cut')
Dim $Text_Copy = IniRead($settings, 'GuiText', 'Copy', 'Copy')
Dim $Text_Paste = IniRead($settings, 'GuiText', 'Paste', 'Paste')
Dim $Text_Delete = IniRead($settings, 'GuiText', 'Delete', 'Delete')
Dim $Text_Select = IniRead($settings, 'GuiText', 'Select', 'Select')
Dim $Text_SelectAll = IniRead($settings, 'GuiText', 'SelectAll', 'Select All')

Dim $Text_Options = IniRead($settings, 'GuiText', 'Options', '&Options')
Dim $Text_AutoSort = IniRead($settings, 'GuiText', 'AutoSort', 'AutoSort')
Dim $Text_SortTree = IniRead($settings, 'GuiText', 'SortTree', 'Sort Tree  - (slow on big lists)')
Dim $Text_PlaySound = IniRead($settings, 'GuiText', 'PlaySound', 'Play sound on new AP')
Dim $Text_AddAPsToTop = IniRead($settings, 'GuiText', 'AddAPsToTop', 'Add new APs to top')

Dim $Text_Extra = IniRead($settings, 'GuiText', 'Extra', 'Ex&tra')
Dim $Text_ScanAPs = IniRead($settings, 'GuiText', 'ScanAPs', '&Scan APs')
Dim $Text_StopScanAps = IniRead($settings, 'GuiText', 'StopScanAps', '&Stop')
Dim $Text_UseGPS = IniRead($settings, 'GuiText', 'UseGPS', 'Use &GPS')
Dim $Text_StopGPS = IniRead($settings, 'GuiText', 'StopGPS', 'Stop &GPS')

Dim $Text_Settings = IniRead($settings, 'GuiText', 'Settings', 'S&ettings')
Dim $Text_GpsSettings = IniRead($settings, 'GuiText', 'GpsSettings', 'G&PS Settings')
Dim $Text_SetLanguage = IniRead($settings, 'GuiText', 'SetLanguage', 'Set &Language')
Dim $Text_SetSearchWords = IniRead($settings, 'GuiText', 'SetSearchWords', 'Set Search &Words')
Dim $Text_SetMacLabel = IniRead($settings, 'GuiText', 'SetMacLabel', 'Set Labels by Mac')
Dim $Text_SetMacManu = IniRead($settings, 'GuiText', 'SetMacManu', 'Set Manufactures by Mac')

Dim $Text_Export = IniRead($settings, 'GuiText', 'Export', 'Ex&port')
Dim $Text_ExportToKML = IniRead($settings, 'GuiText', 'ExportToKML', 'ExportToKML')
Dim $Text_ExportToTXT = IniRead($settings, 'GuiText', 'ExportToTXT', 'ExportToTXT')
Dim $Text_PhilsPHPgraph = IniRead($settings, 'GuiText', 'PhilsPHPgraph', 'View graph (Phils PHP version)')

Dim $Text_RefreshLoopTime = IniRead($settings, 'GuiText', 'RefreshLoopTime', 'Refresh loop time(ms):')
Dim $Text_ActualLoopTime = IniRead($settings, 'GuiText', 'ActualLoopTime', 'Actual loop time:')
Dim $Text_Longitude = IniRead($settings, 'GuiText', 'Longitude', 'Longitude:')
Dim $Text_Latitude = IniRead($settings, 'GuiText', 'Latitude', 'Latitude:')
Dim $Text_ActiveAPs = IniRead($settings, 'GuiText', 'ActiveAPs', 'Active APs:')
Dim $Text_Graph1 = IniRead($settings, 'GuiText', 'Graph1', 'Graph1')
Dim $Text_Graph2 = IniRead($settings, 'GuiText', 'Graph2', 'Graph2')
Dim $Text_NoGraph = IniRead($settings, 'GuiText', 'NoGraph', 'No Graph')
Dim $Text_Active = IniRead($settings, 'GuiText', 'Active', 'Active')
Dim $Text_Dead = IniRead($settings, 'GuiText', 'Dead', 'Dead')

Dim $Text_AddNewLabel = IniRead($settings, 'GuiText', 'AddNewLabel', 'Add New Label To List')
Dim $Text_RemoveLabel = IniRead($settings, 'GuiText', 'RemoveLabel', 'Remove Selected Label From List')
Dim $Text_EditLabel = IniRead($settings, 'GuiText', 'EditLabel', 'Edit Selected Label')
Dim $Text_AddNewMan = IniRead($settings, 'GuiText', 'AddNewMan', 'Add New Manufacturer To List')
Dim $Text_RemoveMan = IniRead($settings, 'GuiText', 'RemoveMan', 'Remove Selected Manufacturer From List')
Dim $Text_EditMan = IniRead($settings, 'GuiText', 'EditMan', 'Edit Selected Manufacturer')
Dim $Text_NewMac = IniRead($settings, 'GuiText', 'NewMac', 'New Mac Address:')
Dim $Text_NewMan = IniRead($settings, 'GuiText', 'NewMan', 'New Manufacturer:')
Dim $Text_NewLabel = IniRead($settings, 'GuiText', 'NewLabel', 'New Label:')

;Create-Array-Of-Manufactures----------------------------
$var = IniReadSection($manufini, "MANUFACURERS")
If Not @error Then
	For $i = 1 To $var[0][0]
		_ArrayAdd($manu_mac, StringUpper($var[$i][0]))
		_ArrayAdd($manu_manu, $var[$i][1])
	Next
	$manu_mac[0] = UBound($manu_mac) - 1
	$manu_manu[0] = UBound($manu_manu) - 1
EndIf

;Create-Array-Of-Labels----------------------------
$var = IniReadSection($labelsini, "LABELS")
If Not @error Then
	For $i = 1 To $var[0][0]
		_ArrayAdd($label_mac, StringUpper($var[$i][0]))
		_ArrayAdd($label_label, $var[$i][1])
	Next
	$label_mac[0] = UBound($label_mac) - 1
	$label_label[0] = UBound($label_label) - 1
EndIf

;Set-Up-Column-Headers-Based-On-INI-File-----------------
$var = IniReadSection($settings, "Columns")
If @error Then
	$headers = 'Active|Mac Address|SSID|Signal|Label|Manufacturer|Authentication|Encryption|Channel|Radio Type|Latitude|Longitude|Basic Transfer Rates|Other Transfer Rates|First Active|Last Updated|Network Type|Signal History|Signal History 2|' 
Else
	For $a = 0 To ($var[0][0] - 1)
		For $b = 1 To $var[0][0]
			If $a = $var[$b][1] Then $headers &= IniRead($settings, 'Column_Names', $var[$b][0], '') & '|' 
		Next
	Next
EndIf

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       GUI
;-------------------------------------------------------------------------------------------------------------------------------
$Vistumbler = GUICreate($title, 908, 692, -1, -1, BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS))
GUISetBkColor($BackgroundColor)

$File = GUICtrlCreateMenu($Text_File)
$SaveAsTXT = GUICtrlCreateMenuItem($Text_SaveAsTXT, $File)
$ImportFromTXT = GUICtrlCreateMenuItem($Text_ImportFromTXT, $File)
$ExitVistumbler = GUICtrlCreateMenuItem($Text_Exit, $File)
;$Edit = GUICtrlCreateMenu("&Edit")
;$Cut = GUICtrlCreateMenuitem("Cut", $Edit)
;$Copy = GUICtrlCreateMenuitem("Copy", $Edit)
;$Delete = GUICtrlCreateMenuitem("Delete", $Edit)
;$SelectAll = GUICtrlCreateMenuitem("Select All", $Edit)
$Options = GUICtrlCreateMenu($Text_Options)
$ScanWifiGUI = GUICtrlCreateMenuItem($Text_ScanAPs, $Options)
$AutoSortGUI = GUICtrlCreateMenuItem($Text_AutoSort, $Options)
If $AutoSort = 1 Then GUICtrlSetState($AutoSortGUI, $GUI_CHECKED)
$SortTree = GUICtrlCreateMenuItem($Text_SortTree, $Options)
$PlaySoundOnNewAP = GUICtrlCreateMenuItem($Text_PlaySound, $Options)
If $SoundOnAP = 1 Then GUICtrlSetState($PlaySoundOnNewAP, $GUI_CHECKED)
$AddNewAPsToTop = GUICtrlCreateMenuItem($Text_AddAPsToTop, $Options)
If $AddDirection = 0 Then GUICtrlSetState(-1, $GUI_CHECKED)
;$ShowGridLines = GUICtrlCreateMenuitem("Show Grid Lines", $Options)
;If $ShowGrid = 1 Then GUICtrlSetState($ShowGridLines, $GUI_CHECKED)

$settingsGUI = GUICtrlCreateMenu($Text_Settings)
$UseGpsGUI = GUICtrlCreateMenuItem($Text_GpsSettings, $settingsGUI)
$SetLanguage = GUICtrlCreateMenuItem($Text_SetLanguage, $settingsGUI)
$SetSearchWords = GUICtrlCreateMenuItem($Text_SetSearchWords, $settingsGUI)
$SetMacLabel = GUICtrlCreateMenuItem($Text_SetMacLabel, $settingsGUI)
$SetMacManu = GUICtrlCreateMenuItem($Text_SetMacManu, $settingsGUI)

$Export = GUICtrlCreateMenu($Text_Export)
$ExportToKML = GUICtrlCreateMenuItem($Text_ExportToKML, $Export)
$ExportToTXT2 = GUICtrlCreateMenuItem($Text_ExportToTXT, $Export)

$Extra = GUICtrlCreateMenu($Text_Extra)
$ViewInPhilsPHP = GUICtrlCreateMenuItem($Text_PhilsPHPgraph, $Extra)


$DataChild = GUICreate("", 895, 595, 0, 60, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $Vistumbler)
GUISetBkColor($BackgroundColor)
$ListviewAPs = GUICtrlCreateListView($headers, 160, 5, 725, 585, $LVS_REPORT + $LVS_SINGLESEL, $LVS_EX_HEADERDRAGDROP + $LVS_EX_GRIDLINES + $LVS_EX_FULLROWSELECT)
GUICtrlSetBkColor(-1, $ControlBackgroundColor)
$TreeviewAPs = GUICtrlCreateTreeView(5, 5, 150, 585)
GUICtrlSetBkColor(-1, $ControlBackgroundColor)
$Graphic1 = GUICtrlCreateGraphic(0, 0, 0, 0)
GUICtrlSetBkColor(-1, $BackgroundColor)
$Graphic2 = GUICtrlCreateGraphic(0, 0, 0, 0)
GUICtrlSetBkColor(-1, $BackgroundColor)

GUISetState()

$ControlChild = GUICreate("", 908, 65, 0, 0, $WS_CHILD, $WS_EX_CONTROLPARENT, $Vistumbler) ; Create Child window for controls
GUISetBkColor($BackgroundColor)
$ScanButton = GUICtrlCreateButton($Text_ScanAPs, 10, 8, 60, 20, 0)
$GpsButton = GUICtrlCreateButton($Text_UseGPS, 75, 8, 60, 20, 0)
$GraphButton1 = GUICtrlCreateButton($Text_Graph1, 10, 35, 60, 20, 0)
$GraphButton2 = GUICtrlCreateButton($Text_Graph2, 75, 35, 60, 20, 0)

GUICtrlCreateLabel($Text_ActiveAPs, 140, 10, 60, 17)
$ActiveAPs = GUICtrlCreateInput('', 205, 7, 90, 21)
GUICtrlCreateLabel($Text_Longitude, 300, 10, 50, 17)
$GuiLon = GUICtrlCreateInput($Longitude, 355, 7, 80, 21)
GUICtrlCreateLabel($Text_Latitude, 440, 10, 45, 17)
$GuiLat = GUICtrlCreateInput($Latitude, 490, 7, 80, 21)

GUICtrlCreateLabel($Text_RefreshLoopTime, 575, 10, 105, 17)
$sleeptime = GUICtrlCreateInput($saved_sleeptime, 685, 7, 55, 21)
GUICtrlCreateLabel($Text_ActualLoopTime, 745, 10, 80, 17)
$timediff = GUICtrlCreateInput('', 830, 7, 70, 21)


$msgdisplay = GUICtrlCreateLabel('', 140, 38, 665, 17)

GUISetState(@SW_SHOW)

GUISwitch($Vistumbler)
_SetControlSizes()
GUISetState(@SW_SHOW)

;Button-Events-------------------------------------------
GUISetOnEvent($GUI_EVENT_CLOSE, 'CLOSEClicked')
GUISetOnEvent($GUI_EVENT_RESIZED, '_ResetSizes')
GUISetOnEvent($GUI_EVENT_MINIMIZE, '_ResetSizes')
GUISetOnEvent($GUI_EVENT_RESTORE, '_ResetSizes')
GUISetOnEvent($GUI_EVENT_MAXIMIZE, '_ResetSizes')
GUICtrlSetOnEvent($ExitVistumbler, 'CLOSEClicked')
GUICtrlSetOnEvent($ScanButton, 'ScanToggle')
GUICtrlSetOnEvent($ScanWifiGUI, 'ScanToggle')
GUICtrlSetOnEvent($UseGpsGUI, '_GPSOptions')
GUICtrlSetOnEvent($GpsButton, '_GpsToggle')
GUICtrlSetOnEvent($AutoSortGUI, '_SortOptions')
GUICtrlSetOnEvent($SaveAsTXT, '_ExportData')
GUICtrlSetOnEvent($ImportFromTXT, 'LoadList')
GUICtrlSetOnEvent($ExportToKML, 'SaveToKML')
GUICtrlSetOnEvent($ExportToTXT2, '_ExportData')
GUICtrlSetOnEvent($PlaySoundOnNewAP, '_SoundToggle')
GUICtrlSetOnEvent($AddNewAPsToTop, '_AddApPosToggle')
GUICtrlSetOnEvent($ListviewAPs, '_SortColumnToggle')
GUICtrlSetOnEvent($SetSearchWords, '_SearchWordsGUI')
GUICtrlSetOnEvent($SortTree, '_SortTree')
GUICtrlSetOnEvent($GraphButton1, '_GraphToggle')
GUICtrlSetOnEvent($GraphButton2, '_GraphToggle2')
GUICtrlSetOnEvent($ViewInPhilsPHP, '_ViewInPhilsPHP')
GUICtrlSetOnEvent($SetLanguage, '_SelectLanguage')
GUICtrlSetOnEvent($SetMacLabel, '_MacLabelGUI')
GUICtrlSetOnEvent($SetMacManu, '_MacManuGUI')





;Set column widths - All variables have ' - 0' after them to make this work. it would not set column widths without the ' - 0'
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Active - 0, $column_Width_Active - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_SSID - 0, $column_Width_SSID - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_BSSID - 0, $column_Width_BSSID - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_MANUF - 0, $column_Width_MANUF - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Signal - 0, $column_Width_Signal - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Authentication - 0, $column_Width_Authentication - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Encryption - 0, $column_Width_Encryption - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_RadioType - 0, $column_Width_RadioType - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Channel - 0, $column_Width_Channel - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Latitude - 0, $column_Width_Latitude - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Longitude - 0, $column_Width_Longitude - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_BasicTransferRates - 0, $column_Width_BasicTransferRates - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_OtherTransferRates - 0, $column_Width_OtherTransferRates - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_FirstActive - 0, $column_Width_FirstActive - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_LastActive - 0, $column_Width_LastActive - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_NetworkType - 0, $column_Width_NetworkType - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Label - 0, $column_Width_Label - 0)

Dim $Authentication_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, $Column_Names_Authentication)
Dim $channel_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, $Column_Names_Channel)
Dim $Encryption_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, $Column_Names_Encryption)
Dim $NetworkType_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, $Column_Names_NetworkType)
Dim $SSID_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, $Column_Names_SSID)

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       PROGRAM RUNNING LOOP
;-------------------------------------------------------------------------------------------------------------------------------

$refresh_gps = TimerInit() ;Start timer for gps refresh
While 1
	$begin = TimerInit() ;Start $begin timer, used to measure loop time
	
	If $Scan = 1 Or $UseGPS = 1 Then
		If $UseGPS = 1 Then ; If 'Use GPS' is checked then scan gps and display information
			$GetGpsSuccess = _GetGPS();Scan for GPS if GPS enabled
			_GpsPositionReset(60000);Reset GPS location to $Latitude = 'N 0.0000000' $Longitude = 'E 0.0000000' if new GPS position not found within timeout _GpsPositionReset($timeout)
			If $GetGpsSuccess = 1 Then
				GUICtrlSetData($msgdisplay, 'Seconds Since GPS Update: ' & Round(TimerDiff($refresh_gps) / 1000) & '/60')
				GUICtrlSetData($GuiLat, $Latitude);Set GPS Latitude in GUI
				GUICtrlSetData($GuiLon, $Longitude);Set GPS Longitude in GUI
			Else
				GUICtrlSetData($msgdisplay, 'GPS Error. Buffer Empty for more than 10 seconds. GPS was probrably disconnected. GPS has been stopped')
				Sleep(1500)
			EndIf
		Else
			GUICtrlSetData($msgdisplay, '') ;Clear Message
		EndIf
		If $Scan = 1 Then _ScanAccessPoints();Scan for Access Points if scanning enabled
		_UpdateList()
		;_SetActiveAccessPoints_SetManufacturer();Reset non-active access points; Set 'Active APs' in GUI
		;MsgBox(0, "", TimerDiff($begin))
		
		If $AutoSort = 1 And TimerDiff($sort_timer) >= ($SortTime * 1000) Then _Sort($SortBy)
		$time = TimerDiff($begin)
		If TimerDiff($begin) <= GUICtrlRead($sleeptime) Then Sleep(GUICtrlRead($sleeptime) - TimerDiff($begin)); If time difference is less then time taken for loop, sleep remaining time
	Else
		;_SetActiveAccessPoints_SetManufacturer ();Reset non-active access points; Set 'Active APs' in GUI
		_UpdateList()
		$time = TimerDiff($begin)
		Sleep(100)
	EndIf
	_GraphApSignal()
	If $SortColumn <> "" Then
		_HeaderSort($SortColumn)
		$SortColumn = ""
	EndIf
	GUICtrlSetData($timediff, Round($time) & ' / ' & Round(TimerDiff($begin))); & 'mS'); Set 'Actual Loop Time' in GUI
WEnd
Exit

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       WIFI SCAN FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _ScanAccessPoints()
	$basetimestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & ':' & @MIN & ':' & @SEC
	$timestamp_timer = TimerInit()
	_RunDOS($netsh & " wlan show networks mode=bssid > " & $tempfile) ;copy the output of the 'netsh wlan show networks mode=bssid' command to the temp file
	_FileReadToArray($tempfile, $TempFileArray);read the tempfile into the '$TempFileArray' Araay
	FileDelete($tempfile)
	For $loop = 1 To $TempFileArray[0]; loop through the temp file array
		If StringInStr($TempFileArray[$loop], $SearchWord_SSID) Then
			Dim $SSID = '', $NetworkType = '', $Authentication = '', $Encryption = '', $BSSID = '', $Signal = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = '', $MANUF ;Clear Variables
			While BitAND(StringInStr($TempFileArray[$loop + 1], $SearchWord_SSID), Not StringInStr($TempFileArray[$loop + 1], $SearchWord_BSSID)) <> 1
				;StringInStr($TempFileArray[$loop + 1], $SearchWord_SSID) <> 1 Or StringInStr($TempFileArray[$loop + 1], $SearchWord_BSSID) = 1
				$temp = StringSplit($TempFileArray[$loop], ":")
				If IsArray($temp) Then ; Strip Data from line
					If StringInStr($temp[1], $SearchWord_SSID) = 1 And StringInStr($temp[1], $SearchWord_BSSID) <> 1 Then
						$SSID = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_NetworkType) Then
						$NetworkType = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_Authentication) Then
						$Authentication = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_Encryption) Then
						$Encryption = StringStripWS($temp[2], 3)
					EndIf
					If StringInStr($temp[1], $SearchWord_BSSID) Then ;
						While 1
							$temp = StringSplit($TempFileArray[$loop], ":")
							If IsArray($temp) Then ; Strip Data from line
								If StringInStr($temp[1], $SearchWord_BSSID) Then
									$BSSID = StringStripWS(StringUpper($temp[2] & ':' & $temp[3] & ':' & $temp[4] & ':' & $temp[5] & ':' & $temp[6] & ':' & $temp[7]), 3)
								ElseIf StringInStr($temp[1], $SearchWord_Signal) Then
									$Signal = StringFormat("%2d", StringTrimRight(StringStripWS($temp[2], 3), 1)) & '%' 
								ElseIf StringInStr($temp[1], $SearchWord_RadioType) Then
									$RadioType = StringStripWS($temp[2], 3)
								ElseIf StringInStr($temp[1], $SearchWord_Channel) Then
									$Channel = StringStripWS($temp[2], 3)
								ElseIf StringInStr($temp[1], $SearchWord_BasicRates) Then
									$BasicTransferRates = StringStripWS($temp[2], 3)
								ElseIf StringInStr($temp[1], $SearchWord_OtherRates) Then
									$OtherTransferRates = StringStripWS($temp[2], 3)
								EndIf
							EndIf
							If StringInStr($TempFileArray[$loop + 1], $SearchWord_SSID) <> 0 Or StringInStr($TempFileArray[$loop + 1], $SearchWord_BSSID) <> 0 Or $TempFileArray[$loop + 1] = '' Or ($loop + 1) >= $TempFileArray[0] Then ExitLoop
							$loop += 1
						WEnd
						If $BSSID <> '' Then ; If Mac Address($BSSID) was not empty then see if it is in the list box. If it is, update it. If not, add it
							$ActiveBSSIDs &= $BSSID & '|'                                                                                                                                           ; Add found BSSID into $ActiveBSSIDs string for use later displaying Active BSSIDs at end of file read
							$ActiveSSIDs &= $SSID & '|'                                                                                                                                           ; Add found BSSID into $ActiveBSSIDs string for use later displaying Active BSSIDs at end of file read
							$timestamp = $basetimestamp & ' ' & Round((TimerDiff($timestamp_timer)))
							;Add Data into the Tmp Arrays for use in _UpdateList()
							_ArrayInsert($TmpArray_BSSID, 1, $BSSID)
							_ArrayInsert($TmpArray_SSID, 1, $SSID)
							_ArrayInsert($TmpArray_Auth, 1, $Authentication)
							_ArrayInsert($TmpArray_Encr, 1, $Encryption)
							_ArrayInsert($TmpArray_Sig, 1, $Signal)
							_ArrayInsert($TmpArray_Chan, 1, $Channel)
							_ArrayInsert($TmpArray_Rad, 1, $RadioType)
							_ArrayInsert($TmpArray_BtX, 1, $BasicTransferRates)
							_ArrayInsert($TmpArray_OtX, 1, $OtherTransferRates)
							_ArrayInsert($TmpArray_NetType, 1, $NetworkType)
							_ArrayInsert($TmpArray_Time, 1, $timestamp)
							Dim $BSSID = '', $Signal = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = ''
						EndIf
					EndIf
				EndIf
				If ($loop + 1) >= $TempFileArray[0] Then ExitLoop ;If Adding 1 to the loop will make it greater than the array size, ExitLoop so no crash happens
				$loop += 1
			WEnd
		EndIf
	Next
	_SetTmpArraySizes()
EndFunc   ;==>_ScanAccessPoints

Func _UpdateList()
	$TmpArray_BSSID[0] = UBound($TmpArray_BSSID) - 1
	$Active = $TmpArray_BSSID[0]
	For $listval = 1 To $DataArray_BSSID[0]
		$addposition = -1
		For $tmplistval = 1 To $TmpArray_BSSID[0]
			If $DataArray_BSSID[$listval] = $TmpArray_BSSID[$tmplistval] Then
				If $DataArray_SSID[$listval] = $TmpArray_SSID[$tmplistval] And _
						$DataArray_Auth[$listval] = $TmpArray_Auth[$tmplistval] And _
						$DataArray_Encr[$listval] = $TmpArray_Encr[$tmplistval] And _
						$DataArray_Chan[$listval] = $TmpArray_Chan[$tmplistval] And _
						$DataArray_NetType[$listval] = $TmpArray_NetType[$tmplistval] Then
					
					Dim $MANUF = '', $LABEL = ''
					$addposition = $DataArray_Row[$listval]
					
					$TrimmedSignal = StringTrimRight($TmpArray_Sig[$tmplistval], 1)
					$CurrentSignal = $TrimmedSignal & "-" & $DataArray_SigHist[$listval]
					If $TrimmedSignal = $DataArray_Sig[$addposition] Then $Signal = ''
					
					If StringTrimLeft($Latitude, 2) = '0.0000000'  Or $Latitude = '' Or StringTrimLeft($Longitude, 2) = '0.0000000'  Or $Longitude = '' Or StringTrimLeft($DataArray_Lat[$addposition], 2) <> '0.0000000'  Then
						Dim $newlat = '', $newlon = ''
					Else
						Dim $newlat = $Latitude, $newlon = $Longitude
					EndIf
					
					$StripedBSSID = StringReplace($DataArray_BSSID[$listval], ':', '')
					If $DataArray_Manu[$listval] = '' Or $ResetManLabel = 1 Then $MANUF = _FindManufacturer(StringTrimRight($StripedBSSID, 6));If the Manufacturer column is empty (or the reset flag has been set), set manufactuere;Finf Manufacturer based on the first six chars of the BSSID
					If $DataArray_Label[$listval] = '' Or $ResetMacLabel = 1 Then $LABEL = _SetLables($StripedBSSID)
					
					_ListViewAdd($addposition, $Text_Active, $MANUF, $TmpArray_Sig[$tmplistval], '', '', '', '', '', '', $newlon, $newlat, '', '', '', $TmpArray_Time[$tmplistval], '', $LABEL)
					
					;Updated data in array
					$DataArray_Active[$listval] = $Text_Active
					$DataArray_BSSID[$listval] = $TmpArray_BSSID[$tmplistval]
					$DataArray_SSID[$listval] = $TmpArray_SSID[$tmplistval]
					$DataArray_Auth[$listval] = $TmpArray_Auth[$tmplistval]
					$DataArray_Encr[$listval] = $TmpArray_Encr[$tmplistval]
					$DataArray_Sig[$listval] = $TmpArray_Sig[$tmplistval]
					$DataArray_Chan[$listval] = $TmpArray_Chan[$tmplistval]
					$DataArray_Rad[$listval] = $TmpArray_Rad[$tmplistval]
					$DataArray_BtX[$listval] = $TmpArray_BtX[$tmplistval]
					$DataArray_OtX[$listval] = $TmpArray_OtX[$tmplistval]
					$DataArray_NetType[$listval] = $TmpArray_NetType[$tmplistval]
					$DataArray_LastTime[$listval] = $TmpArray_Time[$tmplistval]
					$DataArray_SigHist[$listval] = $CurrentSignal
					If $newlon <> '' Then $DataArray_Lon[$listval] = $newlon
					If $newlat <> '' Then $DataArray_Lat[$listval] = $newlat
					If $MANUF <> '' Then $DataArray_Manu[$listval] = $MANUF
					If $LABEL <> '' Then $DataArray_Label[$listval] = $LABEL
					
					;Delete TmpArray row since this is not a new access point
					_ArrayDelete($TmpArray_BSSID, $tmplistval)
					_ArrayDelete($TmpArray_SSID, $tmplistval)
					_ArrayDelete($TmpArray_Auth, $tmplistval)
					_ArrayDelete($TmpArray_Encr, $tmplistval)
					_ArrayDelete($TmpArray_Sig, $tmplistval)
					_ArrayDelete($TmpArray_Chan, $tmplistval)
					_ArrayDelete($TmpArray_Rad, $tmplistval)
					_ArrayDelete($TmpArray_BtX, $tmplistval)
					_ArrayDelete($TmpArray_OtX, $tmplistval)
					_ArrayDelete($TmpArray_NetType, $tmplistval)
					_ArrayDelete($TmpArray_Time, $tmplistval)
					_SetTmpArraySizes()
					ExitLoop
				EndIf
			EndIf
		Next
		If $addposition = -1 And $DataArray_Active[$listval] <> $Text_Dead Then
			Dim $MANUF = '', $LABEL = ''
			If $ResetManLabel = 1 Then
				$StripedBSSID = StringReplace(_GUICtrlListViewGetItemText($ListviewAPs, $DataArray_Row[$listval], $column_BSSID), ':', '')
				$MANUF = _FindManufacturer(StringTrimRight($StripedBSSID, 6))
				$LABEL = _SetLables($StripedBSSID)
			EndIf
			$DataArray_Active[$listval] = $Text_Dead
			$DataArray_Sig[$listval] = '0%' 
			_ListViewAdd($DataArray_Row[$listval], $Text_Dead, $MANUF, '0%', '', '', '', '', '', '', '', '', '', '', '', '', '', $LABEL)
		EndIf
	Next
	
	For $AddAp = 1 To $TmpArray_BSSID[0]
		$TrimmedSignal = StringTrimRight($TmpArray_Sig[$AddAp], 1)


		$StripedBSSID = StringReplace($TmpArray_BSSID[$AddAp], ':', '')
		$MANUF = _FindManufacturer(StringTrimRight($StripedBSSID, 6))
		$LABEL = _SetLables($StripedBSSID)
		$addposition = _GUICtrlListViewInsertItem($ListviewAPs, $AddDirection, '')
		_ListViewAdd($addposition, $Text_Active, $MANUF, $TmpArray_Sig[$AddAp], $TmpArray_SSID[$AddAp], $TmpArray_BSSID[$AddAp], $TmpArray_Auth[$AddAp], $TmpArray_Encr[$AddAp], $TmpArray_Rad[$AddAp], $TmpArray_Chan[$AddAp], $Latitude, $Longitude, $TmpArray_BtX[$AddAp], $TmpArray_OtX[$AddAp], $TmpArray_Time[$AddAp], $TmpArray_Time[$AddAp], $TmpArray_NetType[$AddAp], $LABEL)

		If $AddDirection = 0 Then
			For $ResetRow = 1 To $DataArray_Row[0]
				$DataArray_Row[$ResetRow] += 1
			Next
		EndIf
		;Add AP into the array
		_ArrayInsert($DataArray_Active, 1, $Text_Active)
		_ArrayInsert($DataArray_BSSID, 1, $TmpArray_BSSID[$AddAp])
		_ArrayInsert($DataArray_SSID, 1, $TmpArray_SSID[$AddAp])
		_ArrayInsert($DataArray_Auth, 1, $TmpArray_Auth[$AddAp])
		_ArrayInsert($DataArray_Encr, 1, $TmpArray_Encr[$AddAp])
		_ArrayInsert($DataArray_Sig, 1, $TmpArray_Sig[$AddAp])
		_ArrayInsert($DataArray_Chan, 1, $TmpArray_Chan[$AddAp])
		_ArrayInsert($DataArray_Rad, 1, $TmpArray_Rad[$AddAp])
		_ArrayInsert($DataArray_Lat, 1, $Latitude)
		_ArrayInsert($DataArray_Lon, 1, $Longitude)
		_ArrayInsert($DataArray_BtX, 1, $TmpArray_BtX[$AddAp])
		_ArrayInsert($DataArray_OtX, 1, $TmpArray_OtX[$AddAp])
		_ArrayInsert($DataArray_NetType, 1, $TmpArray_NetType[$AddAp])
		_ArrayInsert($DataArray_FirstTime, 1, $TmpArray_Time[$AddAp])
		_ArrayInsert($DataArray_LastTime, 1, $TmpArray_Time[$AddAp])
		_ArrayInsert($DataArray_SigHist, 1, $TrimmedSignal)
		_ArrayInsert($DataArray_Manu, 1, $MANUF)
		_ArrayInsert($DataArray_Label, 1, $LABEL)
		_ArrayInsert($DataArray_Row, 1, $addposition)
		_SetDataArraySizes()
		$NewApFound = 1
	Next
	If $SoundOnAP = 1 And $NewApFound = 1 Then SoundPlay($SoundDir & $new_AP_sound, 0)
	$NewApFound = 0
	GUICtrlSetData($ActiveAPs, $Active & "/" & $DataArray_BSSID[0])
	;Reset Tmp Arrays to nothing
	Dim $TmpArray_BSSID[1]
	Dim $TmpArray_SSID[1]
	Dim $TmpArray_Auth[1]
	Dim $TmpArray_Encr[1]
	Dim $TmpArray_Sig[1]
	Dim $TmpArray_Chan[1]
	Dim $TmpArray_Rad[1]
	Dim $TmpArray_BtX[1]
	Dim $TmpArray_OtX[1]
	Dim $TmpArray_NetType[1]
	Dim $TmpArray_Time[1]
EndFunc   ;==>_UpdateList

Func _FindManufacturer($findmac = '')
	Dim $return = 'Unknown' 
	For $searchmaclist = 1 To $manu_mac[0]
		If StringStripWS(StringUpper($manu_mac[$searchmaclist]), 3) = StringStripWS(StringUpper($findmac), 3) Then
			$return = $manu_manu[$searchmaclist]
			ExitLoop
		EndIf
	Next
	If $findmac = '' Then $return = ''
	Return ($return)
EndFunc   ;==>_FindManufacturer

Func _SetLables($findmac)
	Dim $return = 'Unknown' 
	For $searchlabellist = 1 To $label_mac[0]
		;msgbox(0, $searchlabellist, $label_mac[$searchlabellist])
		If StringStripWS(StringUpper($label_mac[$searchlabellist]), 3) = StringStripWS(StringUpper($findmac), 3) Then
			$return = $label_label[$searchlabellist]
			ExitLoop
		EndIf
	Next
	Return ($return)
EndFunc   ;==>_SetLables

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       TOGGLE/BUTTON FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _SoundToggle()
	If GUICtrlRead($PlaySoundOnNewAP) = 65 Then
		GUICtrlSetState($PlaySoundOnNewAP, $GUI_UNCHECKED)
		$SoundOnAP = 0
	Else
		GUICtrlSetState($PlaySoundOnNewAP, $GUI_CHECKED)
		$SoundOnAP = 1
	EndIf
EndFunc   ;==>_SoundToggle

Func _SortColumnToggle()
	$SortColumn = GUICtrlGetState($ListviewAPs)
EndFunc   ;==>_SortColumnToggle


Func _AddApPosToggle()
	If GUICtrlRead($AddNewAPsToTop) = 65 Then
		GUICtrlSetState($AddNewAPsToTop, $GUI_UNCHECKED)
		$AddDirection = -1
	Else
		GUICtrlSetState($AddNewAPsToTop, $GUI_CHECKED)
		$AddDirection = 0
	EndIf
EndFunc   ;==>_AddApPosToggle

Func _GpsToggle()
	If $UseGPS = 1 Then
		$UseGPS = 0
		$disconnected_time = -1
		$Latitude = 'N 0.0000000' 
		$Longitude = 'E 0.0000000' 
		_CloseComPort($ComPort) ;Close The GPS COM port
		GUICtrlSetState($UseGpsGUI, $GUI_UNCHECKED)
		GUICtrlSetData($GpsButton, $Text_UseGPS)
	Else
		$openport = _OpenComPort($ComPort, $BAUD);Open The GPS COM port
		If $openport = 1 Then
			$UseGPS = 1
			GUICtrlSetState($UseGpsGUI, $GUI_CHECKED)
			GUICtrlSetData($GpsButton, $Text_StopGPS)
		Else
			$UseGPS = 0
			GUICtrlSetData($msgdisplay, 'Error opening GPS port')
		EndIf
	EndIf
EndFunc   ;==>_GpsToggle

Func _SortToggle()
	If $AutoSort = 1 Then
		$AutoSort = 0
		GUICtrlSetState($AutoSortGUI, $GUI_UNCHECKED)
	Else
		$AutoSort = 1
		GUICtrlSetState($AutoSortGUI, $GUI_CHECKED)
		$sort_timer = TimerInit()
	EndIf
EndFunc   ;==>_SortToggle

Func ScanToggle()
	If $Scan = 1 Then
		$Scan = 0
		GUICtrlSetState($ScanWifiGUI, $GUI_UNCHECKED)
		GUICtrlSetData($ScanButton, $Text_ScanAPs)
	Else
		$Scan = 1
		GUICtrlSetState($ScanWifiGUI, $GUI_CHECKED)
		GUICtrlSetData($ScanButton, $Text_StopScanAps)
	EndIf
EndFunc   ;==>ScanToggle


Func _GraphToggle()
	If $Graph = 1 Then
		$Graph = 0
		GUISwitch($DataChild)
		GUICtrlDelete($Graphic1);delete graphic so it does not show behind the active controls
		GUISwitch($Vistumbler)
	ElseIf $Graph = 2 Then
		$Graph = 1
		GUISwitch($DataChild)
		GUICtrlDelete($Graphic2)
		$Graphic1 = GUICtrlCreateGraphic($Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height);recreate graphic
		GUISwitch($ControlChild)
		GUICtrlSetData($GraphButton2, $Text_Graph2)
		GUISwitch($Vistumbler)
		_ResetSizes()
	ElseIf $Graph = 0 Then
		$Graph = 1
		GUISwitch($DataChild)
		$Graphic1 = GUICtrlCreateGraphic($Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height);recreate graphic
		GUISwitch($Vistumbler)
		_ResetSizes()
	EndIf
	_SetControlSizes()
EndFunc   ;==>_GraphToggle

Func _GraphToggle2()
	If $Graph = 2 Then
		$Graph = 0
		GUISwitch($DataChild)
		GUICtrlDelete($Graphic2);delete graphic so it does not show behind the active controls
		GUISwitch($Vistumbler)
	ElseIf $Graph = 1 Then
		$Graph = 2
		GUISwitch($DataChild)
		GUICtrlDelete($Graphic1)
		$Graphic2 = GUICtrlCreateGraphic($Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height);recreate graphic
		GUISwitch($ControlChild)
		GUICtrlSetData($GraphButton1, $Text_Graph1)
		GUISwitch($Vistumbler)
		_ResetSizes()
	ElseIf $Graph = 0 Then
		$Graph = 2
		GUISwitch($DataChild)
		$Graphic2 = GUICtrlCreateGraphic($Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height);recreate graphic
		GUISwitch($Vistumbler)
		_ResetSizes()
	EndIf
	_SetControlSizes()
EndFunc   ;==>_GraphToggle2

Func CLOSEClicked()
	FileDelete($tempfile);Delete netsh output file
	GUISetState(@SW_HIDE, $Vistumbler)
	_WriteINI(); Write current settings to back to INI file
	If $data_history <> $data_old Then ;If Access point data has changed since load/last save, ask user if they want to save the data
		$savemsg = MsgBox(3, "Save?", "Data has changed. Would you like to save?")
		If $savemsg <> 2 Then
			If $savemsg = 6 Then _ExportData()
			If $UseGPS = 1 Then ;If GPS is active, stop it so the COM port does not stay open
				_GpsToggle()
				;_RunDOS('REGSVR32.EXE /u "' & @ScriptDir & '\NETComm.ocx"');unregister netcomm ocx
				Exit
			Else
				Exit
			EndIf
		EndIf
	Else
		If $UseGPS = 1 Then ;If GPS is active, stop it so the COM port does not stay open
			_GpsToggle()
			Exit
		Else
			Exit
		EndIf
	EndIf
EndFunc   ;==>CLOSEClicked

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       GPS FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _OpenComPort($CommPort = '8', $sBAUD = '4800', $s1 = 'N', $s2 = '8', $s3 = '1')
	$return = 0
	$ComError = 0
	$CommSettings = $sBAUD & ',' & $s1 & ',' & $s2 & ',' & $s3
	;	Create NETComm.ocx object
	$NetComm = ObjCreate("NETCommOCX.NETComm")
	If IsObj($NetComm) = 0 Then ;If $NetComm is not an object then netcomm ocx is probrably not installed
		MsgBox(0, '', 'Install Netcomm OCX')
	Else
		$NetComm.CommPort = $CommPort ;Set port number
		$NetComm.Settings = $CommSettings ;Set port settings
		$NetComm.InputLen = 0 ;reads entire buffer
		If $ComError <> 1 Then
			$NetComm.InputMode = 0 ;reads in text mode
			$NetComm.HandShaking = 3 ;uses both RTS and Xon/Xoff handshaking
			$NetComm.PortOpen = "True" 
			$return = 1
		EndIf
	EndIf
	Return ($return)
EndFunc   ;==>_OpenComPort

Func _CloseComPort($CommPort = '8')
	;Close the COM Port
	With $NetComm
		.CommPort = $CommPort ;Set port number
		.PortOpen = "False"                                                                                                                                           ;Closes specified COM port
	EndWith
EndFunc   ;==>_CloseComPort

Func _GPSOptions()
	$CloseGpsGUI = 0
	Opt("GUIOnEventMode", 0)  ; Turn Off OnEvent mode
	$GpsOptions = GUICreate($Text_GpsSettings, 203, 142, -1, -1)
	GUISetBkColor($BackgroundColor)
	$GUI_UseGPS = GUICtrlCreateCheckbox($Text_UseGPS, 65, 8, 81, 17)
	If $UseGPS = 1 Then GUICtrlSetState($GUI_UseGPS, $GUI_CHECKED)
	GUICtrlCreateLabel("COM:", 32, 40, 31, 17)
	$GUI_Comport = GUICtrlCreateCombo("1", 72, 40, 81, 25)
	GUICtrlSetData(-1, "2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20", $ComPort)
	GUICtrlCreateLabel("Baud:", 32, 72, 32, 17)
	$GUI_Baud = GUICtrlCreateCombo("4800", 72, 72, 81, 25)
	GUICtrlSetData(-1, "9600|14400|19200|38400|57600|115200", $BAUD)
	$GPS_OK = GUICtrlCreateButton($Text_Ok, 32, 104, 65, 25, 0)
	$GPS_Cancel = GUICtrlCreateButton($Text_Cancel, 105, 104, 65, 25, 0)
	GUISetState(@SW_SHOW)
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $GPS_Cancel
				ExitLoop
			Case $GPS_OK
				If GUICtrlRead($GUI_Comport) <> $ComPort And $UseGPS = 1 Then _GpsToggle() ;If the port has changed and gps is turned on then turn off the gps (it will be re-enabled with the new port)
				$ComPort = GUICtrlRead($GUI_Comport)
				$BAUD = GUICtrlRead($GUI_Baud)
				If GUICtrlRead($GUI_UseGPS) = 4 And $UseGPS = 1 Then _GpsToggle()
				If GUICtrlRead($GUI_UseGPS) = 1 And $UseGPS = 0 Then _GpsToggle()
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)  ; Change to OnEvent mode
	GUIDelete($GpsOptions)
EndFunc   ;==>_GPSOptions

Func _GpsPositionReset($timeout = 60000)
	If TimerDiff($refresh_gps) > $timeout Then ;Reset Position to default if a new location has not been found within timeout period
		$Latitude = 'N 0.0000000' 
		$Longitude = 'E 0.0000000' 
		$refresh_gps = TimerInit()
	EndIf
EndFunc   ;==>_GpsPositionReset

Func _GetGPS()
	$LatTest = 0
	$timeout = TimerInit()
	$return = 1
	While 1 ;Loop to extract gps data untill location is found or timout time is reached
		If $UseGPS = 0 Then ExitLoop
		$maxtime = GUICtrlRead($sleeptime) * 0.8
		If $maxtime < 800 Then $maxtime = 800
		
		If $NetComm.InBufferCount Then
			$Buffer = $NetComm.InBufferCount
			If $Buffer > 100 And $LatTest = 0 And TimerDiff($timeout) < $maxtime Then
				$inputdata = $NetComm.inputdata
				$gps = StringSplit($inputdata, "$")
				For $readloop = 1 To $gps[0]
					If StringInStr($gps[$readloop], "GPGGA") Then
						_GetGpsData($gps[$readloop])
						If $LatTest = 1 Then ExitLoop
						If TimerDiff($timeout) > $maxtime Then ExitLoop
					EndIf
				Next
				If $LatTest = 1 Then
					$refresh_gps = TimerInit()
					ExitLoop
				EndIf
			EndIf

			If TimerDiff($timeout) > $maxtime Then
				GUICtrlSetData($msgdisplay, 'GPS Timeout')
				ExitLoop
			EndIf
			Sleep($maxtime / 100)
			$disconnected_time = TimerInit() ;reset gps turn off timer
		Else
			If $disconnected_time = -1 Then $disconnected_time = TimerInit()
			If TimerDiff($disconnected_time) > 10000 Then ; If nothing has been found in the buffer for 5 seconds, turn off gps
				$disconnected_time = -1
				$return = 0
				_GpsToggle()
				SoundPlay($SoundDir & $error_sound, 0)
			EndIf
		EndIf
		
	WEnd
	Return ($return)
EndFunc   ;==>_GetGPS

Func _GetGpsData($GpsData) ;Read GPS Receiver Data
	GUICtrlSetData($msgdisplay, $GpsData)
	$data = StringSplit($GpsData, ",")
	If $data[0] > 9 Then
		$lat = StringSplit($data[3], ".")
		$lon = StringSplit($data[5], ".")
		If _ArrayMax($lat, 0, 1) >= 2 And _ArrayMax($lat, 0, 1) >= 2 Then
			;Convert to Min/Sec to Decimal Latitude
			$latD = StringMid((StringRight($lat[1], 2) & "." & StringRight($lat[2], 4)) / 60, 2, 10)
			;Convert to Min/Sec to Decimal Longitude
			$lonD = StringMid((StringRight($lon[1], 2) & "." & StringRight($lon[2], 4)) / 60, 2, 10)
			;Set Location Variables
			$ufLat = StringLeft($lat[1], StringLen($lat[1]) - 2) & $latD
			$ufLon = StringLeft($lon[1], StringLen($lon[1]) - 2) & $lonD
			$Latitude = $data[4] & ' ' & StringFormat('%0.7f', $ufLat);set latitude
			$Longitude = $data[6] & ' ' & StringFormat('%0.7f', $ufLon);set longitude
			If $Latitude <> '' Then $LatTest = 1
		EndIf
	EndIf
EndFunc   ;==>_GetGpsData

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       SORT FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _SortTree()
	GUICtrlSetData($msgdisplay, 'Sorting Treeview')
	_GUICtrlTreeViewSort($TreeviewAPs)
	GUICtrlSetData($msgdisplay, '')
EndFunc   ;==>_SortTree


Func _SortOptions()
	Opt("GUIOnEventMode", 0)
	
	$SortOptions = GUICreate($Text_AutoSort, 225, 171, -1, -1)
	GUISetBkColor($BackgroundColor)
	$GUI_AutoSort = GUICtrlCreateCheckbox($Text_AutoSort, 72, 8, 73, 17)
	If $AutoSort = 1 Then GUICtrlSetState($GUI_AutoSort, $GUI_CHECKED)
	$GUI_SortBy = GUICtrlCreateCombo('Sort By SSID', 8, 40, 201, 25)
	GUICtrlSetData(-1, 'Sort By Network Type|Sort By Authentication|Sort By Encryption|Sort By BSSID|Sort By Signal|Sort By Radio Type|Sort By Channel|Sort By Basic Transfer Rates|Sort By Other Transfer Rates|Sort By Latitude|Sort By Longitude|Sort By First Active|Sort By Last Active|Sort By Active|Sort By Manufacturer', $SortBy)
	$GUI_SortDirection = GUICtrlCreateCombo('Ascending', 7, 73, 201, 25)
	GUICtrlSetData(-1, 'Decending', $SortDirection)
	GUICtrlCreateLabel("Auto Sort every:", 24, 104, 80, 17)
	$GUI_SortTime = GUICtrlCreateInput($SortTime, 112, 104, 33, 21)
	GUICtrlCreateLabel("Seconds", 152, 104, 46, 17)
	$Sort_OK = GUICtrlCreateButton($Text_Ok, 32, 135, 73, 25, 0)
	$Sort_Cancel = GUICtrlCreateButton($Text_Cancel, 117, 135, 73, 25, 0)
	GUISetState(@SW_SHOW)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $Sort_Cancel
				ExitLoop
			Case $Sort_OK
				$SortBy = GUICtrlRead($GUI_SortBy)
				$SortDirection = GUICtrlRead($GUI_SortDirection)
				$SortTime = GUICtrlRead($GUI_SortTime)
				If GUICtrlRead($GUI_AutoSort) = 4 And $AutoSort = 1 Then _SortToggle()
				If GUICtrlRead($GUI_AutoSort) = 1 And $AutoSort = 0 Then _SortToggle()
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)  ; Change to OnEvent mode
	GUIDelete($SortOptions)
EndFunc   ;==>_SortOptions

Func _HeaderSort($column)
	If $Direction[$column] = 'Ascending'  Then
		Dim $v_sort = _GUICtrlListViewGetSubItemsCount($ListviewAPs)
	Else
		Dim $v_sort[_GUICtrlListViewGetSubItemsCount($ListviewAPs) ]
	EndIf
	If $Direction[$column] = 'Ascending'  Then
		$Direction[$column] = 'Decending' 
	Else
		$Direction[$column] = 'Ascending' 
	EndIf
	_GUICtrlListViewSort($ListviewAPs, $v_sort, $column)
	_ResetArraysFromListview();Reset the data arrays with new data from the listview
EndFunc   ;==>_HeaderSort

Func _Sort($Sort)
	If $AddDirection = 0 Then
		Dim $v_sort = _GUICtrlListViewGetSubItemsCount($ListviewAPs) ;set ascending
	Else
		Dim $v_sort[_GUICtrlListViewGetSubItemsCount($ListviewAPs) ] ;set descending
	EndIf
	
	If $Sort = 'Sort By SSID'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_SSID)
	ElseIf $Sort = 'Sort By Network Type'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_NetworkType)
	ElseIf $Sort = 'Sort By Authentication'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Authentication)
	ElseIf $Sort = 'Sort By Encryption'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Encryption)
	ElseIf $Sort = 'Sort By BSSID'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_BSSID)
	ElseIf $Sort = 'Sort By Signal'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Signal)
	ElseIf $Sort = 'Sort By Radio Type'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_RadioType)
	ElseIf $Sort = 'Sort By Channel'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Channel)
	ElseIf $Sort = 'Sort By Basic Transfer Rates'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_BasicTransferRates)
	ElseIf $Sort = 'Sort By Other Transfer Rates'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_OtherTransferRates)
	ElseIf $Sort = 'Sort By Latitude'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Longitude)
	ElseIf $Sort = 'Sort By Longitude'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Latitude)
	ElseIf $Sort = 'Sort By First Active'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_FirstActive)
	ElseIf $Sort = 'Sort By Last Active'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_LastActive)
	ElseIf $Sort = 'Sort By Active'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Active)
	ElseIf $Sort = 'Sort By Manufacturer'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_MANUF)
	EndIf
	
	;_ResetArraysFromListview();Reset the data arrays with new data from the listview
	$sort_timer = TimerInit()
EndFunc   ;==>_Sort

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       LISTVIEW/TREEVIEW FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _TreeViewAdd()
	$position = ''
	$channel_array[0] = UBound($channel_array) - 1
	For $l = 1 To $channel_array[0]
		If $channel_array[$l] = StringFormat("%02i", $Channel) Then $position = $channel_position[$l]
	Next
	_TreeViewApInfo($position, StringFormat("%02i", $Channel), $channel_array, $channel_position, $channel_tree)
	
	$position = ''
	$SSID_array[0] = UBound($SSID_array) - 1
	For $l = 1 To $SSID_array[0]
		If $SSID_array[$l] = '(' & $SSID & ')'  Then $position = $SSID_position[$l]
	Next
	_TreeViewApInfo($position, '(' & $SSID & ')', $SSID_array, $SSID_position, $SSID_tree)
	
	$position = ''
	$Encryption_array[0] = UBound($Encryption_array) - 1
	For $l = 1 To $Encryption_array[0]
		If $Encryption_array[$l] = $Encryption Then $position = $Encryption_position[$l]
	Next
	_TreeViewApInfo($position, $Encryption, $Encryption_array, $Encryption_position, $Encryption_tree)
	
	$position = ''
	$Authentication_array[0] = UBound($Authentication_array) - 1
	For $l = 1 To $Authentication_array[0]
		If $Authentication_array[$l] = $Authentication Then $position = $Authentication_position[$l]
	Next
	_TreeViewApInfo($position, $Authentication, $Authentication_array, $Authentication_position, $Authentication_tree)
	
	$position = ''
	$NetworkType_array[0] = UBound($NetworkType_array) - 1
	For $l = 1 To $NetworkType_array[0]
		If $NetworkType_array[$l] = $NetworkType Then $position = $NetworkType_position[$l]
	Next
	_TreeViewApInfo($position, $NetworkType, $NetworkType_array, $NetworkType_position, $NetworkType_tree)
	;_GUICtrlTreeViewSort ($TreeviewAPs)
EndFunc   ;==>_TreeViewAdd

Func _TreeViewApInfo($position, $aptxt, ByRef $array1, ByRef $array2, ByRef $tree)
	If $position = '' Then
		$position = _GUICtrlTreeViewInsertItem($TreeviewAPs, $aptxt, $tree)
		_ArrayAdd($array1, $aptxt)
		_ArrayAdd($array2, $position)
	EndIf
	$text = '(' & $SSID & ')' 
	$apinfo = _GUICtrlTreeViewInsertItem($TreeviewAPs, $text, $position)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'SSID : ' & $SSID, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'BSSID : ' & $BSSID, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'NetworkType : ' & $NetworkType, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Encryption : ' & $Encryption, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Radio Type : ' & $RadioType, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Authentication : ' & $Authentication, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Basic Transfer Rates : ' & $BasicTransferRates, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Other Transfer Rates : ' & $OtherTransferRates, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Network Type: : ' & $NetworkType, $apinfo)
EndFunc   ;==>_TreeViewApInfo

Func _ListViewAdd($line, $Add_Active = '', $Add_MANU = '', $Add_Signal = '', $Add_SSID = '', $Add_BSSID = '', $Add_Authentication = '', $Add_Encryption = '', $Add_RadioType = '', $Add_Channel = '', $Add_Latitude = '', $Add_Longitude = '', $Add_BasicTransferRates = '', $Add_OtherTransferRates = '', $Add_FirstAcvtive = '', $Add_LastActive = '', $Add_NetworkType = '', $Add_Label = '')
	If $Add_Active <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Active, $Add_Active)
	If $Add_SSID <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_SSID, $Add_SSID)
	If $Add_BSSID <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_BSSID, $Add_BSSID)
	If $Add_MANU <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_MANUF, $Add_MANU)
	If $Add_Signal <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Signal, $Add_Signal)
	If $Add_Authentication <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Authentication, $Add_Authentication)
	If $Add_Encryption <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Encryption, $Add_Encryption)
	If $Add_RadioType <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_RadioType, $Add_RadioType)
	If $Add_Channel <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Channel, $Add_Channel)
	If $Add_Latitude <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Latitude, $Add_Latitude)
	If $Add_Longitude <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Longitude, $Add_Longitude)
	If $Add_BasicTransferRates <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_BasicTransferRates, $Add_BasicTransferRates)
	If $Add_OtherTransferRates <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_OtherTransferRates, $Add_OtherTransferRates)
	If $Add_FirstAcvtive <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_FirstActive, $Add_FirstAcvtive)
	If $Add_LastActive <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_LastActive, $Add_LastActive)
	If $Add_NetworkType <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_NetworkType, $Add_NetworkType)
	If $Add_Label <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Label, $Add_Label)
EndFunc   ;==>_ListViewAdd

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       SEARCHWORDS FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _SearchWordsGUI()
	Opt("GUIOnEventMode", 0)
	$SearchWordsGUI = GUICreate("netsh search words", 366, 450, -1, -1)
	GUISetBkColor($BackgroundColor)
	GUICtrlCreateGroup("Description", 8, 8, 345, 81)
	GUICtrlCreateLabel("This section allows you to change the words Vistumbler uses to search", 13, 24, 336, 17)
	GUICtrlCreateLabel("netsh. Change to the proper words for you version of windows.", 13, 43, 298, 17)
	GUICtrlCreateLabel("Run 'netsh wlan show networks mode=bssid' to find the proper words.", 13, 64, 332, 17)
	GUICtrlCreateLabel("SSID:", 8, 96, 29, 17)
	GUICtrlCreateLabel("BSSID:", 8, 128, 36, 17)
	GUICtrlCreateLabel("Network Type:", 8, 160, 74, 17)
	GUICtrlCreateLabel("Authentication:", 8, 192, 75, 17)
	GUICtrlCreateLabel("Signal:", 8, 224, 36, 17)
	GUICtrlCreateLabel("Radio Type:", 8, 256, 59, 17)
	GUICtrlCreateLabel("Channel:", 8, 288, 43, 17)
	GUICtrlCreateLabel("Basic Transfer Rates:", 8, 320, 106, 17)
	GUICtrlCreateLabel("Other Transfer Rates:", 8, 352, 106, 17)
	GUICtrlCreateLabel("Encryption:", 8, 384, 106, 17)
	$SearchWord_SSID_GUI = GUICtrlCreateInput($SearchWord_SSID, 120, 96, 233, 21)
	$SearchWord_BSSID_GUI = GUICtrlCreateInput($SearchWord_BSSID, 120, 128, 233, 21)
	$SearchWord_NetType_GUI = GUICtrlCreateInput($SearchWord_NetworkType, 120, 160, 233, 21)
	$SearchWord_Authentication_GUI = GUICtrlCreateInput($SearchWord_Authentication, 120, 192, 233, 21)
	$SearchWord_Signal_GUI = GUICtrlCreateInput($SearchWord_Signal, 120, 224, 233, 21)
	$SearchWord_RadioType_GUI = GUICtrlCreateInput($SearchWord_RadioType, 120, 256, 233, 21)
	$SearchWord_Channel_GUI = GUICtrlCreateInput($SearchWord_Channel, 120, 288, 233, 21)
	$SearchWord_BasicRates_GUI = GUICtrlCreateInput($SearchWord_BasicRates, 120, 320, 233, 21)
	$SearchWord_OtherRates_GUI = GUICtrlCreateInput($SearchWord_OtherRates, 120, 352, 233, 21)
	$SearchWord_Encryption_GUI = GUICtrlCreateInput($SearchWord_Encryption, 120, 384, 233, 21)
	$SearchWordsGUI_OK = GUICtrlCreateButton($Text_Ok, 110, 416, 75, 25, 0)
	$SearchWordsGUI_Cancel = GUICtrlCreateButton($Text_Cancel, 190, 416, 73, 25, 0)
	GUISetState(@SW_SHOW)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $SearchWordsGUI_Cancel
				ExitLoop
			Case $SearchWordsGUI_OK
				$SearchWord_SSID = GUICtrlRead($SearchWord_SSID_GUI)
				$SearchWord_BSSID = GUICtrlRead($SearchWord_BSSID_GUI)
				$SearchWord_NetworkType = GUICtrlRead($SearchWord_NetType_GUI)
				$SearchWord_Authentication = GUICtrlRead($SearchWord_Authentication_GUI)
				$SearchWord_Signal = GUICtrlRead($SearchWord_Signal_GUI)
				$SearchWord_RadioType = GUICtrlRead($SearchWord_RadioType_GUI)
				$SearchWord_Channel = GUICtrlRead($SearchWord_Channel_GUI)
				$SearchWord_BasicRates = GUICtrlRead($SearchWord_BasicRates_GUI)
				$SearchWord_OtherRates = GUICtrlRead($SearchWord_OtherRates_GUI)
				$SearchWord_Encryption = GUICtrlRead($SearchWord_Encryption_GUI)
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)
	GUIDelete($SearchWordsGUI)
EndFunc   ;==>_SearchWordsGUI

Func _SelectLanguage()
	Opt("GUIOnEventMode", 0)
	Dim $Languages1 = '', $Languages2 = ''
	$languagefiles = _FileListToArray($LanguageDir, '*.ini', 1)
	For $b = 1 To $languagefiles[0]
		If $b = 1 Then
			$Languages1 = StringTrimRight($languagefiles[$b], 4)
		ElseIf $b > 1 Then
			$Languages2 &= StringTrimRight($languagefiles[$b], 4)
			If $b < $languagefiles[0] Then $Languages2 &= '|' 
		EndIf
	Next
	
	$LanguageGUI = GUICreate($Text_SetLanguage, 223, 84, -1, -1)
	GUISetBkColor($BackgroundColor)
	$LanguageBox = GUICtrlCreateCombo($Languages1, 16, 16, 193, 25)
	GUICtrlSetData($LanguageBox, $Languages2, $DefaultLanguage)
	$LanguageOk = GUICtrlCreateButton($Text_Ok, 32, 48, 73, 25, 0)
	$LanguageCan = GUICtrlCreateButton($Text_Cancel, 117, 46, 73, 25, 0)
	GUISetState(@SW_SHOW)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $LanguageOk
				$DefaultLanguage = GUICtrlRead($LanguageBox)
				$newlanguagefile = $LanguageDir & $DefaultLanguage & ".ini" 
				$Column_Names_Active = IniRead($newlanguagefile, 'Column_Names', 'Column_Active', 'Active')
				$Column_Names_SSID = IniRead($newlanguagefile, 'Column_Names', 'Column_SSID', 'SSID')
				$Column_Names_BSSID = IniRead($newlanguagefile, 'Column_Names', 'Column_BSSID', 'Mac Address')
				$Column_Names_MANUF = IniRead($newlanguagefile, 'Column_Names', 'Column_Manufacturer', 'Manufacturer')
				$Column_Names_Signal = IniRead($newlanguagefile, 'Column_Names', 'Column_Signal', 'Signal')
				$Column_Names_Authentication = IniRead($newlanguagefile, 'Column_Names', 'Column_Authentication', 'Authentication')
				$Column_Names_Encryption = IniRead($newlanguagefile, 'Column_Names', 'Column_Encryption', 'Encryption')
				$Column_Names_RadioType = IniRead($newlanguagefile, 'Column_Names', 'Column_RadioType', 'Radio Type')
				$Column_Names_Channel = IniRead($newlanguagefile, 'Column_Names', 'Column_Channel', 'Channel')
				$Column_Names_Latitude = IniRead($newlanguagefile, 'Column_Names', 'Column_Latitude', 'Latitude')
				$Column_Names_Longitude = IniRead($newlanguagefile, 'Column_Names', 'Column_Longitude', 'Longitude')
				$Column_Names_BasicTransferRates = IniRead($newlanguagefile, 'Column_Names', 'Column_BasicTransferRates', 'Basic Transfer Rates')
				$Column_Names_OtherTransferRates = IniRead($newlanguagefile, 'Column_Names', 'Column_OtherTransferRates', 'Other Transfer Rates')
				$Column_Names_FirstActive = IniRead($newlanguagefile, 'Column_Names', 'Column_FirstActive', 'First Active')
				$Column_Names_LastActive = IniRead($newlanguagefile, 'Column_Names', 'Column_LastActive', 'Last Active')
				$Column_Names_NetworkType = IniRead($newlanguagefile, 'Column_Names', 'Column_NetworkType', 'Network Type')
				$Column_Names_Label = IniRead($newlanguagefile, 'Column_Names', 'Column_Label', 'Label')
				$Column_Names_SignalHistory = IniRead($newlanguagefile, 'Column_Names', 'Column_SignalHistory', 'Signal History')
				$Column_Names_SignalHistory2 = IniRead($newlanguagefile, 'Column_Names', 'Column_SignalHistory2', 'Signal History 2')
				$SearchWord_SSID = IniRead($newlanguagefile, 'SearchWords', 'SSID', 'SSID')
				$SearchWord_BSSID = IniRead($newlanguagefile, 'SearchWords', 'BSSID', 'BSSID')
				$SearchWord_NetworkType = IniRead($newlanguagefile, 'SearchWords', 'NetworkType', 'Network type')
				$SearchWord_Authentication = IniRead($newlanguagefile, 'SearchWords', 'Authentication', 'Authentication')
				$SearchWord_Encryption = IniRead($newlanguagefile, 'SearchWords', 'Encryption', 'Encryption')
				$SearchWord_Signal = IniRead($newlanguagefile, 'SearchWords', 'Signal', 'Signal')
				$SearchWord_RadioType = IniRead($newlanguagefile, 'SearchWords', 'RadioType', 'Radio Type')
				$SearchWord_Channel = IniRead($newlanguagefile, 'SearchWords', 'Channel', 'Channel')
				$SearchWord_BasicRates = IniRead($newlanguagefile, 'SearchWords', 'BasicRates', 'Basic Rates')
				$SearchWord_OtherRates = IniRead($newlanguagefile, 'SearchWords', 'OtherRates', 'Other Rates')
				$SearchWord_None = IniRead($newlanguagefile, 'SearchWords', 'Open', 'Open')
				$SearchWord_Open = IniRead($newlanguagefile, 'SearchWords', 'None', 'None')
				$Text_Ok = IniRead($newlanguagefile, 'GuiText', 'Ok', '&Ok')
				$Text_Cancel = IniRead($newlanguagefile, 'GuiText', 'Cancel', 'C&ancel')
				$Text_File = IniRead($newlanguagefile, 'GuiText', 'File', '&File')
				$Text_SaveAsTXT = IniRead($newlanguagefile, 'GuiText', 'SaveAsTXT', 'Save As &TXT')
				$Text_ImportFromTXT = IniRead($newlanguagefile, 'GuiText', 'ImportFromTXT', 'Import From &TXT')
				$Text_Exit = IniRead($newlanguagefile, 'GuiText', 'Exit', 'E&xit')
				$Text_Edit = IniRead($newlanguagefile, 'GuiText', 'Edit', 'E&dit')
				$Text_Cut = IniRead($newlanguagefile, 'GuiText', 'Cut', 'Cut')
				$Text_Copy = IniRead($newlanguagefile, 'GuiText', 'Copy', 'Copy')
				$Text_Paste = IniRead($newlanguagefile, 'GuiText', 'Paste', 'Paste')
				$Text_Delete = IniRead($newlanguagefile, 'GuiText', 'Delete', 'Delete')
				$Text_Select = IniRead($newlanguagefile, 'GuiText', 'Select', 'Select')
				$Text_SelectAll = IniRead($newlanguagefile, 'GuiText', 'SelectAll', 'Select All')
				$Text_Options = IniRead($newlanguagefile, 'GuiText', 'Options', '&Options')
				$Text_AutoSort = IniRead($newlanguagefile, 'GuiText', 'AutoSort', 'AutoSort')
				$Text_SortTree = IniRead($newlanguagefile, 'GuiText', 'SortTree', 'Sort Tree  - (slow on big lists)')
				$Text_PlaySound = IniRead($newlanguagefile, 'GuiText', 'PlaySound', 'Play sound on new AP')
				$Text_AddAPsToTop = IniRead($newlanguagefile, 'GuiText', 'AddAPsToTop', 'Add new APs to top')
				$Text_Extra = IniRead($newlanguagefile, 'GuiText', 'Extra', 'Ex&tra')
				$Text_ScanAPs = IniRead($newlanguagefile, 'GuiText', 'ScanAPs', '&Scan APs')
				$Text_StopScanAps = IniRead($newlanguagefile, 'GuiText', 'StopScanAps', '&Stop')
				$Text_UseGPS = IniRead($newlanguagefile, 'GuiText', 'UseGPS', 'Use &GPS')
				$Text_StopGPS = IniRead($newlanguagefile, 'GuiText', 'StopGPS', 'Stop &GPS')
				$Text_Settings = IniRead($newlanguagefile, 'GuiText', 'Settings', 'S&ettings')
				$Text_GpsSettings = IniRead($newlanguagefile, 'GuiText', 'GpsSettings', 'G&PS Settings')
				$Text_SetLanguage = IniRead($newlanguagefile, 'GuiText', 'SetLanguage', 'Set &Language')
				$Text_SetSearchWords = IniRead($newlanguagefile, 'GuiText', 'SetSearchWords', 'Set Search &Words')
				$Text_SetMacLabel = IniRead($newlanguagefile, 'GuiText', 'SetMacLabel', 'Set Labels by Mac')
				$Text_SetMacManu = IniRead($newlanguagefile, 'GuiText', 'SetMacManu', 'Set Manufactures by Mac')
				$Text_Export = IniRead($newlanguagefile, 'GuiText', 'Export', 'Ex&port')
				$Text_ExportToKML = IniRead($newlanguagefile, 'GuiText', 'ExportToKML', 'ExportToKML')
				$Text_ExportToTXT = IniRead($newlanguagefile, 'GuiText', 'ExportToTXT', 'ExportToTXT')
				$Text_PhilsPHPgraph = IniRead($newlanguagefile, 'GuiText', 'PhilsPHPgraph', 'View graph (Phils PHP version)')
				$Text_RefreshLoopTime = IniRead($newlanguagefile, 'GuiText', 'RefreshLoopTime', 'Refresh loop time(ms):')
				$Text_ActualLoopTime = IniRead($newlanguagefile, 'GuiText', 'ActualLoopTime', 'Actual loop time:')
				$Text_Longitude = IniRead($newlanguagefile, 'GuiText', 'Longitude', 'Longitude:')
				$Text_Latitude = IniRead($newlanguagefile, 'GuiText', 'Latitude', 'Latitude:')
				$Text_ActiveAPs = IniRead($newlanguagefile, 'GuiText', 'ActiveAPs', 'Active APs:')
				$Text_Graph1 = IniRead($newlanguagefile, 'GuiText', 'Graph1', 'Graph1')
				$Text_Graph2 = IniRead($newlanguagefile, 'GuiText', 'Graph2', 'Graph2')
				$Text_NoGraph = IniRead($newlanguagefile, 'GuiText', 'NoGraph', 'No Graph')
				$Text_Active = IniRead($newlanguagefile, 'GuiText', 'Active', 'Active')
				$Text_Dead = IniRead($newlanguagefile, 'GuiText', 'Dead', 'Dead')
				$Text_AddNewLabel = IniRead($newlanguagefile, 'GuiText', 'AddNewLabel', 'Add New Label To List')
				$Text_RemoveLabel = IniRead($newlanguagefile, 'GuiText', 'RemoveLabel', 'Remove Selected Label From List')
				$Text_EditLabel = IniRead($newlanguagefile, 'GuiText', 'EditLabel', 'Edit Selected Label')
				$Text_AddNewMan = IniRead($newlanguagefile, 'GuiText', 'AddNewMan', 'Add New Manufacturer To List')
				$Text_RemoveMan = IniRead($newlanguagefile, 'GuiText', 'RemoveMan', 'Remove Selected Manufacturer From List')
				$Text_EditMan = IniRead($newlanguagefile, 'GuiText', 'EditMan', 'Edit Selected Manufacturer')
				$Text_NewMac = IniRead($newlanguagefile, 'GuiText', 'NewMac', 'New Mac Address:')
				$Text_NewMan = IniRead($newlanguagefile, 'GuiText', 'NewMan', 'New Manufacturer:')
				$Text_NewLabel = IniRead($newlanguagefile, 'GuiText', 'NewLabel', 'New Manufacturer:')
				
				_WriteINI()
				MsgBox(0, "Restart Vistumbler", "Please restart Vistumbler for language change to take effect")
				ExitLoop
			Case $LanguageCan
				ExitLoop
			Case $GUI_EVENT_CLOSE
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)
	GUIDelete($LanguageGUI)
EndFunc   ;==>_SelectLanguage

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       GRAPH/CONTROL POSITION FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------
Func _SetControlSizes()
	$a = WinGetPos($Vistumbler)
	WinMove($DataChild, "", 0, 60, $a[2] - 10, $a[3] - 115)
	$b = WinGetPos($DataChild) ;get child window size
	$sizes = $a[0] & '-' & $a[1] & '-' & $a[2] & '-' & $a[3] & '-' & $b[0] & '-' & $b[1] & '-' & $b[2] & '-' & $b[3]
	If $sizes <> $sizes_old Or $Graph <> $Graph_old Or $Redraw = 1 Then
		If $Graph <> 0 Then
			$Graphic_left = ($b[2] * 0.01)
			$Graphic_width = ($b[2] * 0.99) - $Graphic_left
			$Graphic_top = ($b[3] * 0.01)
			$Graphic_height = ($b[3] * 0.64) - $Graphic_top
			
			$ListviewAPs_left = ($b[2] * 0.01)
			$ListviewAPs_width = ($b[2] * 0.99) - $ListviewAPs_left
			$ListviewAPs_top = ($b[3] * 0.65)
			$ListviewAPs_height = ($b[3] * 0.99) - $ListviewAPs_top

			GUICtrlSetState($TreeviewAPs, $GUI_HIDE)
			GUICtrlSetPos($ListviewAPs, $ListviewAPs_left, $ListviewAPs_top, $ListviewAPs_width, $ListviewAPs_height)
			
			If $Graph = 1 Then
				GUICtrlSetPos($Graphic1, $Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height)
				GUICtrlSetData($GraphButton1, $Text_NoGraph)
			ElseIf $Graph = 2 Then
				GUICtrlSetPos($Graphic2, $Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height)
				GUICtrlSetData($GraphButton2, $Text_NoGraph)
			EndIf
			
			GUICtrlSetState($ListviewAPs, $GUI_FOCUS)
			
		Else
			$TreeviewAPs_left = ($b[2] * 0.01)
			$TreeviewAPs_width = ($b[2] * 0.20) - $TreeviewAPs_left
			$TreeviewAPs_top = ($b[3] * 0.01)
			$TreeviewAPs_height = ($b[3] * 0.99) - $TreeviewAPs_top
			
			$ListviewAPs_left = ($b[2] * 0.20) + 1
			$ListviewAPs_width = ($b[2] * 0.99) - $ListviewAPs_left
			$ListviewAPs_top = ($b[3] * 0.01)
			$ListviewAPs_height = ($b[3] * 0.99) - $ListviewAPs_top
			
			GUICtrlSetState($TreeviewAPs, $GUI_SHOW)
			GUICtrlSetPos($ListviewAPs, $ListviewAPs_left, $ListviewAPs_top, $ListviewAPs_width, $ListviewAPs_height)
			GUICtrlSetPos($TreeviewAPs, $TreeviewAPs_left, $TreeviewAPs_top, $TreeviewAPs_width, $TreeviewAPs_height)
			GUICtrlSetData($GraphButton1, $Text_Graph1)
			GUICtrlSetData($GraphButton2, $Text_Graph2)
			GUICtrlSetState($ListviewAPs, $GUI_FOCUS)
		EndIf
		$sizes_old = $sizes
		$Graph_old = $Graph
	EndIf
EndFunc   ;==>_SetControlSizes

Func _GraphApSignal()
	If $Graph <> 0 Then; If the graph tab is selected, run graph script
		$Selected = _GUICtrlListViewGetCurSel($ListviewAPs); find what AP is selected in the list. returns -1 is nothing is selected

		If $Selected <> -1 Then ;If a access point is selected in the listview, map its data
			$BSSID = _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_BSSID)
			$data = ''
			For $finddata = 1 To $DataArray_BSSID[0]
				If $DataArray_BSSID[$finddata] = $BSSID Then
					$SSID = _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_SSID)
					$Channel = _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_Channel)
					$Authentication = _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_Authentication)
					$Encryption = _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_Encryption)
					If $DataArray_SSID[$finddata] = $SSID And $DataArray_Chan[$finddata] = $Channel And $DataArray_Auth[$finddata] = $Authentication And $DataArray_Encr[$finddata] = $Encryption Then
						$data = $DataArray_SigHist[$finddata]
						ExitLoop
					EndIf
				EndIf
			Next
			If $data <> $data_old Or $sizes <> $sizes_old Or $Redraw = 1 Then ; if graph data changed, map new data
				$max_graph_points = 125
				$base_right = $Graphic_width
				$base_left = 0
				$base_top = 0
				$base_bottom = $Graphic_height
				$base_x = $base_right - $base_left
				$base_y = $base_bottom - $base_top

				$max_graph_points = 125
				$Redraw = 0
				$data_old = $data
				$sizes_old = $sizes
				$splitdata = StringSplit($data, '-');Split signals into an array
				If IsArray($splitdata) Then
					If $Graph = 1 Then
						If $splitdata[0] > $max_graph_points Then ; If the array is grater that the max number of ports, set array size to the max size, else use the full size of the array
							$arraylen = $max_graph_points
						Else
							$arraylen = $splitdata[0]
						EndIf
						$base_x_add_value = ($base_x / ($arraylen - 1)); Set disance between points
						$base_y_add_value = ($base_y / 100); set distance for 1%, this will be multplied by the signal strenth later
						
						GUISwitch($DataChild)
						GUICtrlDelete($Graphic1);delete graphic so new data can be added without showing the old data
						$Graphic1 = GUICtrlCreateGraphic($Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height);recreate graphic
						GUISwitch($Vistumbler)
						
						;############### Start - Draw grid ###############
						;GUICtrlSetGraphic($Graphic1, $GUI_GR_PENSIZE, 1);set size of line
						GUICtrlSetGraphic($Graphic1, $GUI_GR_COLOR, 0x000000)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_left, $base_top)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_left, $base_bottom)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_right, $base_top)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_right, $base_bottom)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_left, $base_bottom)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_right, $base_bottom)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_COLOR, 0xff)
						For $drawline = 1 To 10
							$subtract_value = ($drawline * 10) * $base_y_add_value
							GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_left, $base_bottom - $subtract_value)
							GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_right, $base_bottom - $subtract_value)
						Next
						GUICtrlSetGraphic($Graphic1, $GUI_GR_REFRESH)
						;###############  End - Draw grid ###############
						;############### Start Mapping Access Point signal Data ###############
						$base_add = 0
						;GUICtrlSetGraphic($Graphic1, $GUI_GR_PENSIZE, 2);set size of line
						GUICtrlSetGraphic($Graphic1, $GUI_GR_COLOR, 0xFF0000)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_right - $base_add, $base_bottom - ($splitdata[1] * $base_y_add_value))
						GUICtrlSetGraphic($Graphic1, $GUI_GR_DOT, $base_right - $base_add, $base_bottom - ($splitdata[1] * $base_y_add_value))
						For $o = 2 To $arraylen
							$base_add += $base_x_add_value
							
							GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_right - $base_add, $base_bottom - ($splitdata[$o] * $base_y_add_value))
							GUICtrlSetGraphic($Graphic1, $GUI_GR_DOT, $base_right - $base_add, $base_bottom - ($splitdata[$o] * $base_y_add_value))
						Next
						GUICtrlSetGraphic($Graphic1, $GUI_GR_REFRESH)
						;############### Start Mapping Access Point signal Data ###############
					ElseIf $Graph = 2 Then
						If $splitdata[0] > $base_x Then
							$arraylen = $base_x
							$base_subtract = 0
						Else
							$arraylen = $splitdata[0]
							$base_subtract = $base_x - $splitdata[0]
						EndIf
						$base_y_add_value = ($base_y / 100); set distance for 1%, this will be multplied by the signal strenth later
						GUISwitch($DataChild)
						GUICtrlDelete($Graphic2);delete graphic so new data can be added without showing the old data
						$Graphic2 = GUICtrlCreateGraphic($Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height);recreate graphic
						GUISwitch($Vistumbler)
						;############### Start - Draw grid ###############
						GUICtrlSetGraphic($Graphic1, $GUI_GR_PENSIZE, 1);set size of line
						GUICtrlSetGraphic($Graphic2, $GUI_GR_COLOR, 0x000000)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_left, $base_top)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_left, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_right, $base_top)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_right, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_left, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_right, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_COLOR, 0xff)
						For $drawline = 1 To 10
							$subtract_value = ($drawline * 10) * $base_y_add_value
							GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_left, $base_bottom - $subtract_value)
							GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_right, $base_bottom - $subtract_value)
						Next
						;GUICtrlSetGraphic($Graphic2, $GUI_GR_REFRESH)
						;###############  End - Draw grid ###############
						;############### Start Mapping Access Point signal Data ###############
						$base_add = 0
						$base_x_add_value = 1
						;GUICtrlSetGraphic($Graphic1, $GUI_GR_PENSIZE, 2);set size of line
						GUICtrlSetGraphic($Graphic2, $GUI_GR_COLOR, 0xFF0000)
						For $o = 1 To $arraylen
							$base_add += $base_x_add_value
							GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, ($base_right - $base_add) - $base_subtract, $base_bottom)
							GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, ($base_right - $base_add) - $base_subtract, $base_bottom - ($splitdata[$o] * $base_y_add_value))
						Next
						GUICtrlSetGraphic($Graphic1, $GUI_GR_PENSIZE, 1);set size of line
						GUICtrlSetGraphic($Graphic2, $GUI_GR_COLOR, 0x000000)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_left, $base_top)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_left, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_right, $base_top)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_right, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_left, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_right, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_COLOR, 0xff)
						For $drawline = 1 To 10
							$subtract_value = ($drawline * 10) * $base_y_add_value
							GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_left, $base_bottom - $subtract_value)
							GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_right, $base_bottom - $subtract_value)
						Next
						GUICtrlSetGraphic($Graphic2, $GUI_GR_REFRESH)
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
EndFunc   ;==>_GraphApSignal

Func _ResetSizes()
	_SetControlSizes()
	$Redraw = 1
EndFunc   ;==>_ResetSizes

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       SAVE AND OPEN FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _ViewInPhilsPHP()
	$Selected = _GUICtrlListViewGetCurSel($ListviewAPs); find what AP is selected in the list. returns -1 is nothing is selected
	If $Selected <> -1 Then ;If a access point is selected in the listview, map its data
		
		$found = -1
		For $row = 1 To $DataArray_Row[0]
			If $DataArray_Row[$row] = $Selected Then
				$found = $row
				ExitLoop
			EndIf
		Next
		
		If $found <> -1 Then
			;If Ping("randomintervals.com") <> 0 Then
			$url_root = "http://randomintervals.com/wifi/?" 
			$url_data = "SSID=" & $DataArray_SSID[$found] & "&Mac=" & $DataArray_BSSID[$found] & "&Manuf=" & $DataArray_Manu[$found] & "&Auth=" & $DataArray_Auth[$found] & "&Encry=" & $DataArray_Encr[$found] & "&radio=" & $DataArray_Rad[$found] & "&Chn=" & $DataArray_Chan[$found] & "&Lat=" & $DataArray_Lat[$found] & "&Long=" & $DataArray_Lon[$found] & "&BTx=" & $DataArray_BtX[$found] & "&OTx=" & $DataArray_OtX[$found] & "&FA=" & $DataArray_FirstTime[$found] & "&LU=" & $DataArray_LastTime[$found] & "&NT=" & $DataArray_NetType[$found] & "&Label=" & $DataArray_Label[$found] & "&Sig=" & $DataArray_SigHist[$found]
			$url_full = $url_root & $url_data
			$url_trimmed = StringTrimRight($url_full, StringLen($url_full) - 2083) ;trim sting to internet explorer max url lenth
			$url_trimmed2 = StringTrimRight($url_trimmed, (StringLen($url_trimmed) - StringInStr($url_trimmed, "-", 1, -1)) + 1);find - that marks the last full data and get rid of the rest
			Run("RunDll32.exe url.dll,FileProtocolHandler " & $url_trimmed2);open url with rundll 32
			;_IECreate($url_root & $url_data, 0, 1, 0)
			;Else
			;MsgBox(0, "Error", "randomintervals.com did not respond to a ping. this action can't be done at this time.")
			;EndIf
		EndIf
	Else
		MsgBox(0, "Error", "You did not select an access point")
	EndIf
EndFunc   ;==>_ViewInPhilsPHP

Func _ExportData()
	DirCreate($SaveDir)
	$timestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & '-' & @MIN & '-' & @SEC
	$File = FileSaveDialog("Output File", $SaveDir, 'Text (*.txt)', '', $timestamp & '.txt')
	If @error <> 1 Then
		If StringInStr($File, '.txt') = 0 Then $File = $File & '.txt' 
		FileDelete($File)
		For $save = 1 To $DataArray_BSSID[0]
			GUICtrlSetData($msgdisplay, 'Saving Line ' & $save & ' / ' & $DataArray_BSSID[0])
			FileWriteLine($File, $DataArray_SSID[$save] & '|' & $DataArray_BSSID[$save] & '|' & $DataArray_Manu[$save] & '|' & $DataArray_Sig[$save] & '|' & $DataArray_Auth[$save] & '|' & $DataArray_Encr[$save] & '|' & $DataArray_Rad[$save] & '|' & $DataArray_Chan[$save] & '|' & $DataArray_Lat[$save] & '|' & $DataArray_Lon[$save] & '|' & $DataArray_BtX[$save] & '|' & $DataArray_OtX[$save] & '|' & $DataArray_FirstTime[$save] & '|' & $DataArray_LastTime[$save] & '|' & $DataArray_NetType[$save] & '|' & $DataArray_Label[$save] & '|' & $DataArray_SigHist[$save])
		Next
		MsgBox(0, 'Done', 'Saved as: "' & $File & '"')
		GUICtrlSetData($msgdisplay, '')
		$data_old = $data_history
	EndIf
EndFunc   ;==>_ExportData

Func LoadList()
	DirCreate($SaveDir)
	$File = FileOpenDialog("Import File", $SaveDir, 'Text (*.txt)')
	If @error <> 1 Then
		_SetDataArraySizes()
		If StringInStr($File, '.txt') = 0 Then $File = $File & '.txt' 
		_FileReadToArray($File, $OpenArray)
		For $open = 1 To $OpenArray[0] - 1
			GUICtrlSetData($msgdisplay, 'Loading Line ' & $open & ' / ' & $OpenArray[0] - 1)
			$loadlist = StringSplit($OpenArray[$open], '|')
			If IsArray($loadlist) Then
				;MsgBox(0, '', $loadlist[0])
				Dim $SSID = '', $BSSID = '', $MANUF = '', $Signal = '', $Authentication = '', $Encryption = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = '', $LoadLatitude = '', $LoadLongitude = '', $FirstActive = '', $LastActive = '', $NetworkType = '';Clear Variables
				If $loadlist[0] = 17 Or $loadlist[0] = 18 Then
					$SSID = StringStripWS($loadlist[1], 3)
					$BSSID = StringStripWS($loadlist[2], 3)
					If $loadlist[3] <> 'Unknown'  Then $MANUF = StringStripWS($loadlist[3], 3)
					;$Signal = StringStripWS($loadlist[4], 3)
					$Authentication = StringStripWS($loadlist[5], 3)
					$Encryption = StringStripWS($loadlist[6], 3)
					$RadioType = StringStripWS($loadlist[7], 3)
					$Channel = StringStripWS($loadlist[8], 3)
					$LoadLatitude = StringStripWS($loadlist[9], 3)
					$LoadLongitude = StringStripWS($loadlist[10], 3)
					$BasicTransferRates = StringStripWS($loadlist[11], 3)
					$OtherTransferRates = StringStripWS($loadlist[12], 3)
					$FirstActive = StringStripWS($loadlist[13], 3)
					$LastActive = StringStripWS($loadlist[14], 3)
					$NetworkType = StringStripWS($loadlist[15], 3)
					;$LABEL = StringStripWS($loadlist[16], 3)
					$SignalHistory = StringStripWS($loadlist[17], 3)
					If $loadlist[0] = 18 Then $SignalHistory &= StringStripWS($loadlist[18], 3)
					If $BSSID <> '' Then ; If Mac Address(BSSID) was found write data into
						$arraysearch = -1
						
						For $findloop = 1 To $DataArray_BSSID[0]
							If $DataArray_BSSID[$findloop] = $BSSID Then
								If $DataArray_SSID[$findloop] = $SSID And $DataArray_Auth[$findloop] = $Authentication And $DataArray_Encr[$findloop] = $Encryption And $DataArray_Chan[$findloop] = $Channel And $DataArray_Rad[$findloop] = $RadioType Then
									$arraysearch = $DataArray_Row[$findloop];$DataArray_Row[$findloop]
									ExitLoop
								EndIf
							EndIf
						Next
						
						If $arraysearch = -1 Then ;If BSSID is not found, add it - Else - Update old entry
							$new = _GUICtrlListViewInsertItem($ListviewAPs, -1, '')
							$StripedBSSID = StringReplace($BSSID, ':', '')
							$MANUF = _FindManufacturer(StringTrimRight($StripedBSSID, 6));If the Manufacturer column is empty (or the reset flag has been set), set manufactuere;Finf Manufacturer based on the first six chars of the BSSID
							$LABEL = _SetLables($StripedBSSID)
							_ListViewAdd($new, $Text_Dead, $MANUF, '0%', $SSID, $BSSID, $Authentication, $Encryption, $RadioType, $Channel, $LoadLatitude, $LoadLongitude, $BasicTransferRates, $OtherTransferRates, $FirstActive, $LastActive, $NetworkType, $LABEL)
							_TreeViewAdd()
							;Add AP into the array
							If $AddDirection = 0 Then
								For $ResetRow = 1 To $DataArray_Row[0]
									$DataArray_Row[$ResetRow] += 1
								Next
							EndIf
							_ArrayAdd($DataArray_Active, $Text_Dead)
							_ArrayAdd($DataArray_BSSID, $BSSID)
							_ArrayAdd($DataArray_SSID, $SSID)
							_ArrayAdd($DataArray_Auth, $Authentication)
							_ArrayAdd($DataArray_Encr, $Encryption)
							_ArrayAdd($DataArray_Sig, "0%")
							_ArrayAdd($DataArray_Chan, $Channel)
							_ArrayAdd($DataArray_Rad, $RadioType)
							_ArrayAdd($DataArray_Lon, $newlon)
							_ArrayAdd($DataArray_Lat, $newlat)
							_ArrayAdd($DataArray_BtX, $BasicTransferRates)
							_ArrayAdd($DataArray_OtX, $OtherTransferRates)
							_ArrayAdd($DataArray_NetType, $NetworkType)
							_ArrayAdd($DataArray_FirstTime, $FirstActive)
							_ArrayAdd($DataArray_LastTime, $LastActive)
							_ArrayAdd($DataArray_SigHist, $SignalHistory)
							_ArrayAdd($DataArray_Manu, $MANUF)
							_ArrayAdd($DataArray_Label, $LABEL)
							_ArrayAdd($DataArray_Row, $new)
							;_SetDataArraySizes()
						Else
							Dim $MANUF = '', $LABEL = ''
							$addposition = $DataArray_Row[$arraysearch]
							$CurrentSignal = $DataArray_SigHist[$arraysearch] & '-' & $SignalHistory

							If StringTrimLeft($newlat, 2) = '0.0000000'  Or $newlat = '' Or StringTrimLeft($newlon, 2) = '0.0000000'  Or $newlon = '' Or StringTrimLeft($DataArray_Lat[$arraysearch], 2) <> '0.0000000'  Then
								Dim $newlat = '', $newlon = ''
							EndIf
							
							$StripedBSSID = StringReplace($BSSID, ':', '')
							If $DataArray_Manu[$arraysearch] = '' Then $MANUF = _FindManufacturer(StringTrimRight($StripedBSSID, 6));If the Manufacturer column is empty (or the reset flag has been set), set manufactuere;Finf Manufacturer based on the first six chars of the BSSID
							If $DataArray_Label[$arraysearch] = '' Then $LABEL = _SetLables($StripedBSSID)
							
							_ListViewAdd($addposition, $Text_Dead, $MANUF, '', '', '', '', '', '', '', $newlon, $newlat, '', '', '', $FirstActive, $LastActive, $LABEL)
							
							$DataArray_Lon[$arraysearch] = $Longitude
							$DataArray_Lat[$arraysearch] = $Latitude
							$DataArray_FirstTime[$arraysearch] = $FirstActive
							$DataArray_FirstTime[$arraysearch] = $LastActive
							$DataArray_SigHist[$arraysearch] = $CurrentSignal
							MsgBox(0, '', $CurrentSignal)
							$DataArray_Manu[$arraysearch] = $MANUF
							$DataArray_Label[$arraysearch] = $LABEL
						EndIf
					EndIf
				EndIf
			EndIf
		Next
		_SetDataArraySizes()
		MsgBox(0, 'Done', 'Load of file: "' & $File & '" complete')
		GUICtrlSetData($msgdisplay, "")
	EndIf
	$data_old = $data_history
	$ResetMacLabel = 1
	$ResetManLabel = 1
EndFunc   ;==>LoadList

Func SaveToKML()
	DirCreate($SaveDir)
	$timestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & '-' & @MIN & '-' & @SEC
	$kml = FileSaveDialog("Google Earth Output File", $SaveDir, 'Google Earth (*.kml)', '', $timestamp & '.kml')
	If @error <> 1 Then
		If StringInStr($kml, '.kml') = 0 Then $kml = $kml & '.kml' 
		FileDelete($kml)
		$File = '<?xml version="1.0" encoding="utf-8"?>' & @CRLF _
				 & '<kml xmlns="http://earth.google.com/kml/2.0">' & @CRLF _
				 & '<Document>' & @CRLF _
				 & '<Style id="secureStyle">' & @CRLF _
				 & '<IconStyle>' & @CRLF _
				 & '<scale>.5</scale>' & @CRLF _
				 & '<Icon>' & @CRLF _
				 & '<href>http://techidiots.net/autoit-scripts/vistumbler/wap-secure.png</href>' & @CRLF _;image from EarthStubler
				 & '</Icon>' & @CRLF _
				 & '</IconStyle>' & @CRLF _
				 & '</Style>' & @CRLF _
				 & '<Style id="openStyle">' & @CRLF _
				 & '<IconStyle>' & @CRLF _
				 & '<scale>.5</scale>' & @CRLF _
				 & '<Icon>' & @CRLF _
				 & '<href>http://techidiots.net/autoit-scripts/vistumbler/wap-open.png</href>' & @CRLF _;image from EarthStubler
				 & '</Icon>' & @CRLF _
				 & '</IconStyle>' & @CRLF _
				 & '</Style>' & @CRLF _
				 & '<Folder>' & @CRLF _
				 & '<description>' & $Script_Name & ' - By ' & $Script_Author & '</description>' & @CRLF _
				 & '<name>' & $Script_Name & ' ' & $version & '</name>' & @CRLF _
				 & '<Folder>' & @CRLF _
				 & '<name>Access Points</name>' & @CRLF _
				 & '<description>Access points found</description>' & @CRLF
		
		$FoundApWithGps = 0
		For $i = 1 To $DataArray_BSSID[0]
			GUICtrlSetData($msgdisplay, 'Saving Line ' & $i & ' / ' & $DataArray_BSSID[0])
			If $DataArray_Lat[$i] <> '' And $DataArray_Lon[$i] <> 'N 0.0000000'  Then
				$File &= '<Placemark>' & @CRLF _
						 & '<name></name>' & @CRLF _
						 & '<description><![CDATA[<b>SSID: </b>' & $DataArray_SSID[$i] & '<br /><b>BSSID: </b>' & $DataArray_BSSID[$i] & '<br /><b>Network Type: </b>' & $DataArray_NetType[$i] & '<br /><b>Radio Type: </b>' & $DataArray_Rad[$i] & '<br /><b>Channel: </b>' & $DataArray_Chan[$i] & '<br /><b>Authentication: </b>' & $DataArray_Auth[$i] & '<br /><b>Encryption: </b>' & $DataArray_Encr[$i] & '<br /><b>Basic Rates: </b>' & $DataArray_BtX[$i] & '<br /><b>Other Rates: </b>' & $DataArray_OtX[$i] & '<br /><b>First Seen: </b>' & $DataArray_FirstTime[$i] & '<br /><b>Last Seen: </b>' & $DataArray_LastTime[$i] & '<br /><b>Latitude: </b>' & $DataArray_Lat[$i] & '<br /><b>Longitude: </b>' & $DataArray_Lon[$i] & '<br /><b>Manufacturer: </b>' & $DataArray_Manu[$i] & '<br /><b>Signal History: </b>' & $DataArray_SigHist[$i] & '<br />]]></description>' 
				If $DataArray_Auth[$i] = $SearchWord_Open And $DataArray_Encr[$i] = $SearchWord_None Then
					$File &= '	<styleUrl>#openStyle</styleUrl>' & @CRLF
				Else
					$File &= '	<styleUrl>#secureStyle</styleUrl>' & @CRLF
				EndIf
				
				$File &= '<Point>' & @CRLF _
						 & '<coordinates>' & StringReplace(StringReplace(StringReplace($DataArray_Lon[$i], 'W', '-'), 'E', ''), ' ', '') & ',' & StringReplace(StringReplace(StringReplace($DataArray_Lat[$i], 'S', '-'), 'N', ''), ' ', '') & ',0</coordinates>' & @CRLF _
						 & '</Point>' & @CRLF _
						 & '</Placemark>' & @CRLF
				$FoundApWithGps = 1
			EndIf
		Next
		
		$File &= '</Folder>' & @CRLF _
				 & '</Folder>' & @CRLF _
				 & '</Document>' & @CRLF _
				 & '</kml>' & @CRLF
		
		If $FoundApWithGps = 1 Then
			FileWrite($kml, $File)
			MsgBox(0, 'Done', 'Saved as: "' & $kml & '"')
			GUICtrlSetData($msgdisplay, '')
		Else
			MsgBox(0, 'Done', 'No Access Points found with GPS coordinates. No file has been saved')
			GUICtrlSetData($msgdisplay, '')
		EndIf
	EndIf
EndFunc   ;==>SaveToKML

Func _WriteINI()
	;Get new order of columns to write back to INI
	$currentcolumn = StringSplit(_GUICtrlListViewGetColumnOrder($ListviewAPs), '|')
	;_ArrayDisplay($currentcolumn)
	For $c = 1 To $currentcolumn[0]
		If $column_Active = $currentcolumn[$c] Then
			$save_column_Active = $c - 1
		ElseIf $column_SSID = $currentcolumn[$c] Then
			$save_column_SSID = $c - 1
		ElseIf $column_BSSID = $currentcolumn[$c] Then
			$save_column_BSSID = $c - 1
		ElseIf $column_MANUF = $currentcolumn[$c] Then
			$save_column_MANUF = $c - 1
		ElseIf $column_Signal = $currentcolumn[$c] Then
			$save_column_Signal = $c - 1
		ElseIf $column_Authentication = $currentcolumn[$c] Then
			$save_column_Authentication = $c - 1
		ElseIf $column_Encryption = $currentcolumn[$c] Then
			$save_column_Encryption = $c - 1
		ElseIf $column_RadioType = $currentcolumn[$c] Then
			$save_column_RadioType = $c - 1
		ElseIf $column_Channel = $currentcolumn[$c] Then
			$save_column_Channel = $c - 1
		ElseIf $column_Latitude = $currentcolumn[$c] Then
			$save_column_Latitude = $c - 1
		ElseIf $column_Longitude = $currentcolumn[$c] Then
			$save_column_Longitude = $c - 1
		ElseIf $column_BasicTransferRates = $currentcolumn[$c] Then
			$save_column_BasicTransferRates = $c - 1
		ElseIf $column_OtherTransferRates = $currentcolumn[$c] Then
			$save_column_OtherTransferRates = $c - 1
		ElseIf $column_FirstActive = $currentcolumn[$c] Then
			$save_column_FirstActive = $c - 1
		ElseIf $column_LastActive = $currentcolumn[$c] Then
			$save_column_LastActive = $c - 1
		ElseIf $column_NetworkType = $currentcolumn[$c] Then
			$save_column_NetworkType = $c - 1
		ElseIf $column_Label = $currentcolumn[$c] Then
			$save_column_Label = $c - 1
		EndIf
	Next

	;write ini settings
	IniWrite($settings, "Vistumbler", "Netsh_exe", $netsh)
	IniWrite($settings, "Vistumbler", "ComPort", $ComPort)
	IniWrite($settings, "Vistumbler", "Baud", $BAUD)
	IniWrite($settings, "Vistumbler", "Sleeptime", GUICtrlRead($sleeptime))
	IniWrite($settings, "Vistumbler", "AutoSortTime", $SortTime)
	IniWrite($settings, "Vistumbler", "SortCombo", $SortBy)
	IniWrite($settings, "Vistumbler", "AscDecDefault", $SortDirection)
	IniWrite($settings, "Vistumbler", "AutoSort", $AutoSort)
	IniWrite($settings, "Vistumbler", "NewAP_Sound", $new_AP_sound)
	IniWrite($settings, "Vistumbler", "Error_Sound", $error_sound)
	IniWrite($settings, "Vistumbler", "NewApPosistion", $AddDirection)
	IniWrite($settings, "Vistumbler", "Language", $DefaultLanguage)
	If GUICtrlRead($PlaySoundOnNewAP) = 65 Then
		IniWrite($settings, "Vistumbler", "PlaySoundOnNewAP", 1)
	Else
		IniWrite($settings, "Vistumbler", "PlaySoundOnNewAP", 0)
	EndIf
	
	IniWrite($settings, "Columns", "Column_Active", $save_column_Active)
	IniWrite($settings, "Columns", "Column_SSID", $save_column_SSID)
	IniWrite($settings, "Columns", "Column_BSSID", $save_column_BSSID)
	IniWrite($settings, "Columns", "Column_Manufacturer", $save_column_MANUF)
	IniWrite($settings, "Columns", "Column_Signal", $save_column_Signal)
	IniWrite($settings, "Columns", "Column_Authentication", $save_column_Authentication)
	IniWrite($settings, "Columns", "Column_Encryption", $save_column_Encryption)
	IniWrite($settings, "Columns", "Column_RadioType", $save_column_RadioType)
	IniWrite($settings, "Columns", "Column_Channel", $save_column_Channel)
	IniWrite($settings, "Columns", "Column_Latitude", $save_column_Latitude)
	IniWrite($settings, "Columns", "Column_Longitude", $save_column_Longitude)
	IniWrite($settings, "Columns", "Column_BasicTransferRates", $save_column_BasicTransferRates)
	IniWrite($settings, "Columns", "Column_OtherTransferRates", $save_column_OtherTransferRates)
	IniWrite($settings, "Columns", "Column_FirstActive", $save_column_FirstActive)
	IniWrite($settings, "Columns", "Column_LastActive", $save_column_LastActive)
	IniWrite($settings, "Columns", "Column_NetworkType", $save_column_NetworkType)
	IniWrite($settings, "Columns", "Column_Label", $save_column_Label)
	
	IniWrite($settings, "Column_Width", "Column_Active", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Active - 0))
	IniWrite($settings, "Column_Width", "Column_SSID", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_SSID - 0))
	IniWrite($settings, "Column_Width", "Column_BSSID", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_BSSID - 0))
	IniWrite($settings, "Column_Width", "Column_Manufacturer", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_MANUF - 0))
	IniWrite($settings, "Column_Width", "Column_Signal", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Signal - 0))
	IniWrite($settings, "Column_Width", "Column_Authentication", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Authentication - 0))
	IniWrite($settings, "Column_Width", "Column_Encryption", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Encryption - 0))
	IniWrite($settings, "Column_Width", "Column_RadioType", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_RadioType - 0))
	IniWrite($settings, "Column_Width", "Column_Channel", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Channel - 0))
	IniWrite($settings, "Column_Width", "Column_Latitude", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Latitude - 0))
	IniWrite($settings, "Column_Width", "Column_Longitude", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Longitude - 0))
	IniWrite($settings, "Column_Width", "Column_BasicTransferRates", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_BasicTransferRates - 0))
	IniWrite($settings, "Column_Width", "Column_OtherTransferRates", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_OtherTransferRates - 0))
	IniWrite($settings, "Column_Width", "Column_FirstActive", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_FirstActive - 0))
	IniWrite($settings, "Column_Width", "Column_LastActive", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_LastActive - 0))
	IniWrite($settings, "Column_Width", "Column_NetworkType", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_NetworkType - 0))
	IniWrite($settings, "Column_Width", "Column_Label", _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Label - 0))

	IniWrite($settings, "Column_Names", "Column_Active", $Column_Names_Active)
	IniWrite($settings, "Column_Names", "Column_SSID", $Column_Names_SSID)
	IniWrite($settings, "Column_Names", "Column_BSSID", $Column_Names_BSSID)
	IniWrite($settings, "Column_Names", "Column_Manufacturer", $Column_Names_MANUF)
	IniWrite($settings, "Column_Names", "Column_Signal", $Column_Names_Signal)
	IniWrite($settings, "Column_Names", "Column_Authentication", $Column_Names_Authentication)
	IniWrite($settings, "Column_Names", "Column_Encryption", $Column_Names_Encryption)
	IniWrite($settings, "Column_Names", "Column_RadioType", $Column_Names_RadioType)
	IniWrite($settings, "Column_Names", "Column_Channel", $Column_Names_Channel)
	IniWrite($settings, "Column_Names", "Column_Latitude", $Column_Names_Latitude)
	IniWrite($settings, "Column_Names", "Column_Longitude", $Column_Names_Longitude)
	IniWrite($settings, "Column_Names", "Column_BasicTransferRates", $Column_Names_BasicTransferRates)
	IniWrite($settings, "Column_Names", "Column_OtherTransferRates", $Column_Names_OtherTransferRates)
	IniWrite($settings, "Column_Names", "Column_FirstActive", $Column_Names_FirstActive)
	IniWrite($settings, "Column_Names", "Column_LastActive", $Column_Names_LastActive)
	IniWrite($settings, "Column_Names", "Column_NetworkType", $Column_Names_NetworkType)
	IniWrite($settings, "Column_Names", "Column_Label", $Column_Names_Label)
	
	IniWrite($settings, "SearchWords", "SSID", $SearchWord_SSID)
	IniWrite($settings, "SearchWords", "BSSID", $SearchWord_BSSID)
	IniWrite($settings, "SearchWords", "NetworkType", $SearchWord_NetworkType)
	IniWrite($settings, "SearchWords", "Authentication", $SearchWord_Authentication)
	IniWrite($settings, "SearchWords", "Encryption", $SearchWord_Encryption)
	IniWrite($settings, "SearchWords", "Signal", $SearchWord_Signal)
	IniWrite($settings, "SearchWords", "RadioType", $SearchWord_RadioType)
	IniWrite($settings, "SearchWords", "Channel", $SearchWord_Channel)
	IniWrite($settings, "SearchWords", "BasicRates", $SearchWord_BasicRates)
	IniWrite($settings, "SearchWords", "OtherRates", $SearchWord_OtherRates)
	IniWrite($settings, "SearchWords", "Open", $SearchWord_Open)
	IniWrite($settings, "SearchWords", "None", $SearchWord_None)
	
	IniWrite($settings, "GuiText", "Ok", $Text_Ok)
	IniWrite($settings, "GuiText", "Cancel", $Text_Cancel)
	IniWrite($settings, "GuiText", "File", $Text_File)
	IniWrite($settings, "GuiText", "SaveAsTXT", $Text_SaveAsTXT)
	IniWrite($settings, "GuiText", "ImportFromTXT", $Text_ImportFromTXT)
	IniWrite($settings, "GuiText", "Exit", $Text_Exit)
	IniWrite($settings, "GuiText", "Edit", $Text_Edit)
	IniWrite($settings, "GuiText", "Cut", $Text_Cut)
	IniWrite($settings, "GuiText", "Copy", $Text_Copy)
	IniWrite($settings, "GuiText", "Paste", $Text_Paste)
	IniWrite($settings, "GuiText", "Delete", $Text_Delete)
	IniWrite($settings, "GuiText", "Select", $Text_Select)
	IniWrite($settings, "GuiText", "SelectAll", $Text_SelectAll)
	IniWrite($settings, "GuiText", "Options", $Text_Options)
	IniWrite($settings, "GuiText", "AutoSort", $Text_AutoSort)
	IniWrite($settings, "GuiText", "SortTree", $Text_SortTree)
	IniWrite($settings, "GuiText", "PlaySound", $Text_PlaySound)
	IniWrite($settings, "GuiText", "AddAPsToTop", $Text_AddAPsToTop)
	IniWrite($settings, "GuiText", "Extra", $Text_Extra)
	IniWrite($settings, "GuiText", "ScanAPs", $Text_ScanAPs)
	IniWrite($settings, "GuiText", "StopScanAps", $Text_StopScanAps)
	IniWrite($settings, "GuiText", "UseGPS", $Text_UseGPS)
	IniWrite($settings, "GuiText", "StopGPS", $Text_StopGPS)
	IniWrite($settings, "GuiText", "Settings", $Text_Settings)
	IniWrite($settings, "GuiText", "GpsSettings", $Text_GpsSettings)
	IniWrite($settings, "GuiText", "SetLanguage", $Text_SetLanguage)
	IniWrite($settings, "GuiText", "SetSearchWords", $Text_SetSearchWords)
	IniWrite($settings, "GuiText", "Export", $Text_Export)
	IniWrite($settings, "GuiText", "ExportToKML", $Text_ExportToKML)
	IniWrite($settings, "GuiText", "ExportToTXT", $Text_ExportToTXT)
	IniWrite($settings, "GuiText", "PhilsPHPgraph", $Text_PhilsPHPgraph)
	IniWrite($settings, "GuiText", "RefreshLoopTime", $Text_RefreshLoopTime)
	IniWrite($settings, "GuiText", "ActualLoopTime", $Text_ActualLoopTime)
	IniWrite($settings, "GuiText", "Longitude", $Text_Longitude)
	IniWrite($settings, "GuiText", "Latitude", $Text_Latitude)
	IniWrite($settings, "GuiText", "ActiveAPs", $Text_ActiveAPs)
	IniWrite($settings, "GuiText", "Graph1", $Text_Graph1)
	IniWrite($settings, "GuiText", "Graph2", $Text_Graph2)
	IniWrite($settings, "GuiText", "NoGraph", $Text_NoGraph)
	IniWrite($settings, 'GuiText', 'SetMacLabel', $Text_SetMacLabel)
	IniWrite($settings, 'GuiText', 'SetMacManu', $Text_SetMacManu)
	IniWrite($settings, 'GuiText', 'Active', $Text_Active)
	IniWrite($settings, 'GuiText', 'Dead', $Text_Dead)
	IniWrite($settings, 'GuiText', 'AddNewLabel', $Text_AddNewLabel)
	IniWrite($settings, 'GuiText', 'RemoveLabel', $Text_RemoveLabel)
	IniWrite($settings, 'GuiText', 'EditLabel', $Text_EditLabel)
	IniWrite($settings, 'GuiText', 'AddNewMan', $Text_AddNewMan)
	IniWrite($settings, 'GuiText', 'RemoveMan', $Text_RemoveMan)
	IniWrite($settings, 'GuiText', 'EditMan', $Text_EditMan)
	IniWrite($settings, 'GuiText', 'NewMac', $Text_NewMac)
	IniWrite($settings, 'GuiText', 'NewMan', $Text_NewMan)
	IniWrite($settings, 'GuiText', 'NewLabel', $Text_NewLabel)
	
EndFunc   ;==>_WriteINI

Func MyErrFunc()
	$ComError = 1
EndFunc   ;==>MyErrFunc

#include <GUIConstants.au3>

Func _MacLabelGUI()
	Opt("GUIOnEventMode", 0)
	$MacLabelGUI = GUICreate($Text_SetMacLabel, 651, 530, -1, -1)
	GUISetBkColor($BackgroundColor)
	GUICtrlCreateLabel($Text_NewMac, 8, 16, 94, 17)
	$NewMacAddress = GUICtrlCreateInput("", 104, 16, 105, 21)
	GUICtrlCreateLabel($Text_NewLabel, 224, 16, 100, 17)
	$NewLabel = GUICtrlCreateInput("", 330, 16, 315, 21)
	$AddLabel = GUICtrlCreateButton($Text_AddNewLabel, 8, 50, 200, 25, 0)
	$RemoveLabel = GUICtrlCreateButton($Text_RemoveLabel, 225, 50, 200, 25, 0)
	$EditLabel = GUICtrlCreateButton($Text_EditLabel, 444, 50, 200, 25, 0)
	$LabelList = GUICtrlCreateListView($Column_Names_BSSID & "|" & $Column_Names_Label, 8, 88, 633, 401, $LVS_REPORT, $LVS_EX_HEADERDRAGDROP + $LVS_EX_GRIDLINES + $LVS_EX_FULLROWSELECT)
	_GUICtrlListViewSetColumnWidth($LabelList, 0, 130)
	_GUICtrlListViewSetColumnWidth($LabelList, 1, 480)
	GUICtrlSetBkColor(-1, $ControlBackgroundColor)
	For $m = 1 To $label_mac[0]
		$arraysearch = _GUICtrlListViewInsertItem($LabelList, $AddDirection, '')
		_GUICtrlListViewSetItemText($LabelList, $arraysearch, 0, $label_mac[$m])
		_GUICtrlListViewSetItemText($LabelList, $arraysearch, 1, $label_label[$m])
	Next
	$MacLabelGuiOk = GUICtrlCreateButton($Text_Ok, 240, 495, 73, 25, 0)
	$MacLabelGuiCancel = GUICtrlCreateButton($Text_Cancel, 323, 495, 73, 25, 0)
	GUISetState(@SW_SHOW)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $AddLabel
				$StrippedMac = StringUpper(StringReplace(StringReplace(StringReplace(GUICtrlRead($NewMacAddress), ":", ""), "-", ""), " ", ""))
				$MacLabel_AddMac = $StrippedMac
				$MacLabel_AddLabel = GUICtrlRead($NewLabel)
				$arraysearch = -1
				$itemcount = _GUICtrlListViewGetItemCount($LabelList) - 1; Get List Size
				For $findloop = 0 To $itemcount; Find BSSID list; If found, set $arraysearch with position
					If _GUICtrlListViewGetItemText($LabelList, $findloop, 0) = $MacLabel_AddMac Then
						$arraysearch = $findloop
						ExitLoop
					EndIf
				Next
				If $arraysearch = -1 Then
					$arraysearch = _GUICtrlListViewInsertItem($LabelList, 0, '')
					_GUICtrlListViewSetItemText($LabelList, $arraysearch, 0, $MacLabel_AddMac)
					_GUICtrlListViewSetItemText($LabelList, $arraysearch, 1, $MacLabel_AddLabel)
				Else
					$overwrite_entry = MsgBox(4, "Overwrite?", "A entry for this mac address already exists. would you like to overwrite it?")
					If $overwrite_entry = 6 Then
						_GUICtrlListViewSetItemText($LabelList, $arraysearch, 0, $MacLabel_AddMac)
						_GUICtrlListViewSetItemText($LabelList, $arraysearch, 1, $MacLabel_AddLabel)
					EndIf
				EndIf
			Case $EditLabel
				$EditLine = _GUICtrlListViewGetCurSel($LabelList)
				If $EditLine <> $LV_ERR Then
					$EditMac = _GUICtrlListViewGetItemText($LabelList, $EditLine, 0)
					$EditLab = _GUICtrlListViewGetItemText($LabelList, $EditLine, 1)
					$EditMaclabelForm = GUICreate($Text_Set, 625, 86, -1, -1)
					GUICtrlCreateLabel("Mac Address:", 16, 16, 105, 17)
					$EditMac_Mac = GUICtrlCreateInput($EditMac, 224, 16, 100, 17)
					GUICtrlCreateLabel("Label:", 232, 16, 33, 17)
					$EditMac_Label = GUICtrlCreateInput($EditLab, 272, 16, 337, 21)
					$EditMac_OK = GUICtrlCreateButton($Text_Ok, 200, 48, 97, 25, 0)
					$EditMac_Can = GUICtrlCreateButton($Text_Cancel, 312, 48, 97, 25, 0)
					GUISetState(@SW_SHOW)
					While 1
						$nMsg = GUIGetMsg()
						If $nMsg = $GUI_EVENT_CLOSE Then ExitLoop
						If $nMsg = $EditMac_Can Then ExitLoop
						If $nMsg = $EditMac_OK Then
							$StrippedMac = StringUpper(StringReplace(StringReplace(StringReplace(GUICtrlRead($EditMac_Mac), ":", ""), "-", ""), " ", ""))
							_GUICtrlListViewSetItemText($LabelList, $EditLine, 0, $StrippedMac)
							_GUICtrlListViewSetItemText($LabelList, $EditLine, 1, GUICtrlRead($EditMac_Label))
							ExitLoop
						EndIf
					WEnd
					GUIDelete($EditMaclabelForm)
				EndIf
			Case $RemoveLabel
				$EditLine = _GUICtrlListViewGetCurSel($LabelList)
				If $EditLine <> $LV_ERR Then _GUICtrlListViewDeleteItem($LabelList, $EditLine)
			Case $MacLabelGuiOk
				For $m = 0 To $label_mac[0];Remove all current Mac address labels in the array
					$DeleteArray = ($label_mac[0] - $m)
					If $DeleteArray = 0 Then
						$label_mac[0] = 0
					Else
						_ArrayDelete($label_mac, $DeleteArray)
						_ArrayDelete($label_label, $DeleteArray)
					EndIf
				Next
				$itemcount = _GUICtrlListViewGetItemCount($LabelList) - 1; Get List Size
				For $findloop = 0 To $itemcount ;Rewrite Mac address label from listview into the array
					_ArrayAdd($label_mac, _GUICtrlListViewGetItemText($LabelList, $itemcount - $findloop, 0))
					_ArrayAdd($label_label, _GUICtrlListViewGetItemText($LabelList, $itemcount - $findloop, 1))
				Next
				$label_mac[0] = UBound($label_mac) - 1
				$label_label[0] = UBound($label_label) - 1

				$ResetMacLabel = 1;Set flag so lables get reset
				
				IniDelete($labelsini, "LABELS");rewrite label ini
				For $m = 1 To $label_mac[0]
					IniWrite($labelsini, "LABELS", $label_mac[$m], $label_label[$m])
				Next
				
				ExitLoop
			Case $MacLabelGuiCancel
				ExitLoop
			Case $GUI_EVENT_CLOSE
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)
	GUIDelete($MacLabelGUI)
EndFunc   ;==>_MacLabelGUI

Func _MacManuGUI()
	Opt("GUIOnEventMode", 0)
	$MacManuGUI = GUICreate($Text_SetMacManu, 651, 530, -1, -1)
	GUISetBkColor($BackgroundColor)
	GUICtrlCreateLabel($Text_NewMac, 8, 16, 94, 17)
	$NewMacAddress = GUICtrlCreateInput("", 104, 16, 105, 21)
	GUICtrlCreateLabel($Text_NewMan, 224, 16, 100, 17)
	$NewManu = GUICtrlCreateInput("", 330, 16, 315, 21)
	$AddManu = GUICtrlCreateButton($Text_AddNewMan, 8, 50, 200, 25, 0)
	$RemoveManu = GUICtrlCreateButton($Text_RemoveMan, 225, 50, 205, 25, 0)
	$EditManu = GUICtrlCreateButton($Text_EditMan, 444, 50, 200, 25, 0)
	$ManuList = GUICtrlCreateListView($Column_Names_BSSID & "|" & $Column_Names_MANUF, 8, 88, 633, 401, $LVS_REPORT, $LVS_EX_HEADERDRAGDROP + $LVS_EX_GRIDLINES + $LVS_EX_FULLROWSELECT)
	GUICtrlSetBkColor(-1, $ControlBackgroundColor)
	_GUICtrlListViewSetColumnWidth($ManuList, 0, 160)
	_GUICtrlListViewSetColumnWidth($ManuList, 1, 450)
	For $m = 1 To $manu_mac[0]
		$arraysearch = _GUICtrlListViewInsertItem($ManuList, $AddDirection, '')
		_GUICtrlListViewSetItemText($ManuList, $arraysearch, 0, $manu_mac[$m])
		_GUICtrlListViewSetItemText($ManuList, $arraysearch, 1, $manu_manu[$m])
	Next
	$MacManuGuiOk = GUICtrlCreateButton($Text_Ok, 240, 495, 73, 25, 0)
	$MacManuGuiCancel = GUICtrlCreateButton($Text_Cancel, 323, 495, 73, 25, 0)
	GUISetState(@SW_SHOW)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $AddManu
				$StrippedMac = StringUpper(StringReplace(StringReplace(StringReplace(GUICtrlRead($NewMacAddress), ":", ""), "-", ""), " ", ""))
				$MacManu_AddMac = StringTrimRight($StrippedMac, StringLen($StrippedMac) - 6)
				$MacManu_AddManu = GUICtrlRead($NewManu)
				$arraysearch = -1
				$itemcount = _GUICtrlListViewGetItemCount($ManuList) - 1; Get List Size
				For $findloop = 0 To $itemcount; Find BSSID list; If found, set $arraysearch with position
					If _GUICtrlListViewGetItemText($ManuList, $findloop, 0) = $MacManu_AddMac Then
						$arraysearch = $findloop
						ExitLoop
					EndIf
				Next
				If $arraysearch = -1 Then
					$arraysearch = _GUICtrlListViewInsertItem($ManuList, 0, '')
					_GUICtrlListViewSetItemText($ManuList, $arraysearch, 0, $MacManu_AddMac)
					_GUICtrlListViewSetItemText($ManuList, $arraysearch, 1, $MacManu_AddManu)
				Else
					$overwrite_entry = MsgBox(4, "Overwrite?", "A entry for this mac address already exists. would you like to overwrite it?")
					If $overwrite_entry = 6 Then
						_GUICtrlListViewSetItemText($ManuList, $arraysearch, 0, $MacManu_AddMac)
						_GUICtrlListViewSetItemText($ManuList, $arraysearch, 1, $MacManu_AddManu)
					EndIf
				EndIf
			Case $EditManu
				$EditLine = _GUICtrlListViewGetCurSel($ManuList)
				If $EditLine <> $LV_ERR Then
					$EditMac = _GUICtrlListViewGetItemText($ManuList, $EditLine, 0)
					$EditLab = _GUICtrlListViewGetItemText($ManuList, $EditLine, 1)
					$EditMacManuForm = GUICreate("Edit Mac Manufacturer", 625, 86, -1, -1)
					GUICtrlCreateLabel("Mac Address:", 16, 16, 69, 17)
					$EditMac_Mac = GUICtrlCreateInput($EditMac, 88, 16, 137, 21)
					GUICtrlCreateLabel("Manufacturer:", 230, 16, 70, 17)
					$EditMac_Manu = GUICtrlCreateInput($EditLab, 305, 16, 300, 21)
					$EditMac_OK = GUICtrlCreateButton($Text_Ok, 200, 48, 97, 25, 0)
					$EditMac_Can = GUICtrlCreateButton($Text_Cancel, 312, 48, 97, 25, 0)
					GUISetState(@SW_SHOW)
					While 1
						$nMsg = GUIGetMsg()
						If $nMsg = $GUI_EVENT_CLOSE Then ExitLoop
						If $nMsg = $EditMac_Can Then ExitLoop
						If $nMsg = $EditMac_OK Then
							$StrippedMac = StringUpper(StringReplace(StringReplace(StringReplace(GUICtrlRead($EditMac_Mac), ":", ""), "-", ""), " ", ""))
							_GUICtrlListViewSetItemText($ManuList, $EditLine, 0, StringTrimRight($StrippedMac, StringLen($StrippedMac) - 6))
							_GUICtrlListViewSetItemText($ManuList, $EditLine, 1, GUICtrlRead($EditMac_Manu))
							ExitLoop
						EndIf
					WEnd
					GUIDelete($EditMacManuForm)
				EndIf
			Case $RemoveManu
				$EditLine = _GUICtrlListViewGetCurSel($ManuList)
				If $EditLine <> $LV_ERR Then _GUICtrlListViewDeleteItem($ManuList, $EditLine)
			Case $MacManuGuiOk
				For $m = 0 To $manu_mac[0];Remove all current Mac address manufacturers in the array
					$DeleteArray = ($manu_mac[0] - $m)
					If $DeleteArray = 0 Then
						$manu_mac[0] = 0
						$manu_manu[0] = 0
					Else
						_ArrayDelete($manu_mac, $DeleteArray)
						_ArrayDelete($manu_manu, $DeleteArray)
					EndIf
				Next
				$itemcount = _GUICtrlListViewGetItemCount($ManuList) - 1; Get List Size
				For $findloop = 0 To $itemcount ;Rewrite Mac address manufacturer from listview into the array
					_ArrayAdd($manu_mac, _GUICtrlListViewGetItemText($ManuList, $itemcount - $findloop, 0))
					_ArrayAdd($manu_manu, _GUICtrlListViewGetItemText($ManuList, $itemcount - $findloop, 1))
				Next
				$manu_mac[0] = UBound($manu_mac) - 1
				$manu_manu[0] = UBound($manu_manu) - 1

				$ResetManLabel = 1;Set flag so lables get reset
				
				IniDelete($manufini, "MANUFACURERS");rewrite manufacturer ini
				For $m = 1 To $manu_mac[0]
					IniWrite($manufini, "MANUFACURERS", $manu_mac[$m], $manu_manu[$m])
				Next
				
				ExitLoop
			Case $MacManuGuiCancel
				ExitLoop
			Case $GUI_EVENT_CLOSE
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)
	GUIDelete($MacManuGUI)
EndFunc   ;==>_MacManuGUI

Func _ResetArraysFromListview()
	_SetDataArraySizes()
	$itemcount = _GUICtrlListViewGetItemCount($ListviewAPs) - 1; Get List Size
	For $lisviewrow = 0 To $itemcount ;Reset AP rows in array
		For $arrayrow = 1 To $DataArray_BSSID[0]
			If $DataArray_BSSID[$arrayrow] = _GUICtrlListViewGetItemText($ListviewAPs, $lisviewrow, $column_BSSID) Then
				If $DataArray_SSID[$arrayrow] = _GUICtrlListViewGetItemText($ListviewAPs, $lisviewrow, $column_SSID) And _
						$DataArray_Auth[$arrayrow] = _GUICtrlListViewGetItemText($ListviewAPs, $lisviewrow, $column_Authentication) And _
						$DataArray_Encr[$arrayrow] = _GUICtrlListViewGetItemText($ListviewAPs, $lisviewrow, $column_Encryption) And _
						$DataArray_Chan[$arrayrow] = _GUICtrlListViewGetItemText($ListviewAPs, $lisviewrow, $column_Channel) And _
						$DataArray_Rad[$arrayrow] = _GUICtrlListViewGetItemText($ListviewAPs, $lisviewrow, $column_RadioType) Then
					$DataArray_Row[$arrayrow] = $lisviewrow
				EndIf
			EndIf
		Next
	Next
EndFunc   ;==>_ResetArraysFromListview

Func _SetDataArraySizes()
	$DataArray_Active[0] = UBound($DataArray_Active) - 1
	$DataArray_BSSID[0] = UBound($DataArray_BSSID) - 1
	$DataArray_SSID[0] = UBound($DataArray_SSID) - 1
	$DataArray_Auth[0] = UBound($DataArray_Auth) - 1
	$DataArray_Encr[0] = UBound($DataArray_Encr) - 1
	$DataArray_Sig[0] = UBound($DataArray_Sig) - 1
	$DataArray_Chan[0] = UBound($DataArray_Chan) - 1
	$DataArray_Rad[0] = UBound($DataArray_Rad) - 1
	$DataArray_Lon[0] = UBound($DataArray_Lon) - 1
	$DataArray_Lat[0] = UBound($DataArray_Lat) - 1
	$DataArray_BtX[0] = UBound($DataArray_BtX) - 1
	$DataArray_OtX[0] = UBound($DataArray_OtX) - 1
	$DataArray_NetType[0] = UBound($DataArray_NetType) - 1
	$DataArray_FirstTime[0] = UBound($DataArray_FirstTime) - 1
	$DataArray_LastTime[0] = UBound($DataArray_LastTime) - 1
	$DataArray_SigHist[0] = UBound($DataArray_SigHist) - 1
	$DataArray_Manu[0] = UBound($DataArray_Manu) - 1
	$DataArray_Label[0] = UBound($DataArray_Label) - 1
	$DataArray_Row[0] = UBound($DataArray_Row) - 1
EndFunc   ;==>_SetDataArraySizes

Func _SetTmpArraySizes()
	$TmpArray_BSSID[0] = UBound($TmpArray_BSSID) - 1
	$TmpArray_SSID[0] = UBound($TmpArray_SSID) - 1
	$TmpArray_Auth[0] = UBound($TmpArray_Auth) - 1
	$TmpArray_Encr[0] = UBound($TmpArray_Encr) - 1
	$TmpArray_Sig[0] = UBound($TmpArray_Sig) - 1
	$TmpArray_Chan[0] = UBound($TmpArray_Chan) - 1
	$TmpArray_Rad[0] = UBound($TmpArray_Rad) - 1
	$TmpArray_BtX[0] = UBound($TmpArray_BtX) - 1
	$TmpArray_OtX[0] = UBound($TmpArray_OtX) - 1
	$TmpArray_NetType[0] = UBound($TmpArray_NetType) - 1
	$TmpArray_Time[0] = UBound($TmpArray_Time) - 1
EndFunc   ;==>_SetTmpArraySizes